{ MNANRUF.PAS - Anruf-Behandlung, Zeitabfolge etc. }

unit mnAnruf;

{$A-,B-,E-,N-,R+,S+,V-}

interface

uses
  Crt,dos,m7config,m7utillo,m7disk,
  m7time,m7dec,m7utilg,m7msg,m7RawIni,
  mnDef,m7Raw,mnLog,mnProto,mnMittHi,mnUtil
  {$ifdef OS2} ,use32 {$endif};

type
  PhasenTyp = (Anfang,VonUnten,NachOben,VonOben,NachUnten);
var
  PhasenLimit,PhasenConfig: array[PhasenTyp] of integer;
  AmEndeAbheben: boolean;
const
  ForcePort: byte = 0;

procedure CostLogInit;
procedure SetPhasenLimits;

procedure MacheNachtnetz;
procedure MultiVerbindungZu(ToBoxen: BoxSet; TimeOutZeit: integer);
procedure MultiVerbindungVon(FromBoxen: BoxSet; TimeOutZeit: integer);
procedure UebernehmeAnruf;

procedure ModemInit;
procedure AnrufInit;


IMPLEMENTATION

const
  FehlerZuTeuer   = 100;
  InitString      = 'k@b.y'; { alles klar?! }
  ModemOk         : boolean = false;
type
  VerbindungsStatus = (vOk, vNotOk, vMaus);
const
  VStatusTxt: array[VerbindungsStatus] of string[13] =
    ('Ok', 'Nicht Ok', 'MAUS erreicht');
type
  CostLogDir = (InLog,OutLog,NoLog);
var
  CostLogFile: array[CostLogDir] of text;
const
  CostLogName: array[CostLogDir] of string[12] =
    ('MN-IN.LOG','MN-OUT.LOG','');
var
  nochAnrufVon,
  nochAnrufen     : BoxSet;
  FehlerKosten    : array [AnrufStatus] of Integer;
  FehlerVerbindung: Integer;
  Fehler          : array [Box] of Integer;
  PackFile        : array [1..DefDirectBoxMax] of FileStr;
  OnModem         : array [1..DefDirectBoxMax] of word;
  CallDelay       : Integer;
  DialPre,
  DialPost,
  DialNumber      : array[1..DefDirectBoxMax] of string[40];
const
  BothDir         : Boolean = false; { bertragung in beide Richtungen }
  Bidirect        : Boolean = false; { .. gleichzeitig }
var
  VDate, VTime    : integer;
  IchWarteSeit    : SecondInt;
  SeineVersNr     : string[4];
  Funkuhr,          { wir haben eine Funkuhr (oder eine Funkuhr-Zeit) }
  UhrAbgleich     : boolean; { Uhr nach Funkuhr-Zeit stellen }
  FunkuhrDiff     : SecondInt;
  MinFree         : word; { KB minimal frei }
  InitToMAUSCount,
  InitToMAUSDelay,
  InitToNetDelay  : word;
  UhrAbgleichMax  : word;
  ErwartePackZeit : word;
  GepacktIst      : BoxSet;
  WarteAufPacken  : word;
  AbwimmelFile    : string;
  Ich, Er         : NetBlock;
  SendOk,
  RcvOk           : Boolean;

{======================== Kosten-Log-File-Verwaltung =========================}

const
  CostLogOpen : boolean = false;

procedure CostLogInit;
var
  c: CostLogDir;
begin
  for c:=InLog to OutLog do begin
    {$I-}
    assign(CostLogFile[c],CostLogName[c]);
    reset(CostLogFile[c]);
    {$I+}
    if ioresult=0 then
      append(CostLogFile[c])
    else begin
      rewrite(CostLogFile[c]);
      writeln(CostLogFile[c],'Datum          Box      Ergebnis       Secs  Recs   cps');
      writeln(CostLogFile[c],'');
      { Beispiel:             01.05.92 03:55 SL       Ok               25     5    94 }
    end;
    if FlushLog then begin
      close(CostLogFile[c]);
      append(CostLogFile[c]);
    end;
  end;
  CostLogOpen := true;
end;

procedure CostLogExit;
var
  c: CostLogDir;
begin
  if CostLogOpen then
  for c:=InLog to OutLog do
    close(CostLogFile[c]);
end;

procedure CostLog(dir: CostLogDir; txt: string; b: box; VDate, VTime: integer;
                  status: Verbindungsstatus; Secs: integer; Recs,cps: longint);
var
  s: string;
  KBstr: string[10];
begin
  if (secs<0) or (secs>99*60) then begin
    SysopProt(BoxName(b) + ': ' + IntToStr(Secs) + ' Sekunden ??');
    secs := 1;
  end;
  if dir <> NoLog then begin
    write(CostLogFile[dir], DatumSeit(VDate), ' ', ZeitSeit(VTime), ' ', AlignL(BoxName(b),9));
    s := VStatusTxt[status];
    writeln(CostLogFile[dir],AlignL(s,13),Secs:6,Recs:6,cps:6);
    if FlushLog then begin
      close(CostLogFile[dir]);
      append(CostLogFile[dir]);
    end;
  end;
  if status = vOk then begin
    s := txt + AlignL(BoxName(b),8) + ':  ';
    if secs = 0 then s := s + '          '
      else s := s + ZeitSeit(secs)+' min,';
    str(recs/8:8:1, KBstr);
    s := s + KBstr +' KB,'
               + AlignR(IntToStr(cps) ,6)+' cps';
    if (dir=OutLog) and (Fehler[b]>0) then
      s := s + ','+ AlignR(IntToStr(Fehler[b]),5) + '% Fehler.'
    else
      s := s + '.';
    SysopProt(s);
    {--- Verbindungsreport im Logfile }
    case dir of
      OutLog: s := 'Gesendet:';
      InLog: s := 'Empfangen:';
      NoLog: s := 'Bidirektional:';
    end;
    writeln(log, AlignL(s, 19), LTrim(KBstr), ' KB, ', IntToStr(cps), ' cps');
  end;
end;

procedure ReportStart(AnrufTxt: string; B: Box; Secs: word);
begin { Hallo Fritz! }
  writeln(log);
  writeln(log, 'Verbindungsreport: ', AnrufTxt, ' MAUS ', BoxName(B));
  writeln(log, 'Dauer:             ', Secs, ' Sekunden');
end;

procedure ReportEnde(vStatus: VerbindungsStatus; ZusatzTxt: string);
begin
  write(log, 'Status:            ', VStatusTxt[vStatus]);
  if ZusatzTxt <> '' then
    write(log, ' (', ZusatzTxt, ')');
  writeln(log);
  writeln(log);
end;

{========================== Modem-Lolevel-Routinen ===========================}

const
  ModemSound: boolean = false;

procedure ToggleSound;
var
  Act: byte;
  p, i: integer;
  SoundOn: boolean;
begin
  ModemSound := not ModemSound;
  if ModemSound then
    write(log, '<Sound: on>')
  else
    write(log, '<Sound: off>');
  Act := ActModem;
  for i := 1 to ModemPorts do begin
   if ModemOn(i) then begin
    SetModem(i);
    p := pos('M', Modem^.Auflegen)+1;
    if p = 1 then p := pos('m', Modem^.Auflegen)+1;
    if p = 1 then begin
      Modem^.Auflegen := 'M0' + Modem^.Auflegen;
      SoundOn := false;
      p := 2;
    end else
      SoundOn := Modem^.Auflegen[p] = '1';
    if SoundOn <> ModemSound then begin
      if ModemSound then
        Modem^.Auflegen[p] := '1'
      else
        Modem^.Auflegen[p] := '0';
      Modems[i]^.LStatus := lNil; { um das Auflegen zu forcen }
      m7raw.Auflegen;
    end;
   end;
  end;
  SetModem(Act);
end;

procedure ModemInit;
var
  i, p: integer;

  procedure OthersOff(m: ModemRange);
  var
    i: integer;
  begin
    for i:=1 to MaxModems do
      if (Modems[i]<>nil) and (i<>m) then
        Modems[i]^.On := false;
  end;

begin
  if NetMode = VerbindungUebernehmen then begin
    if (MausVar.ActModem > 0) and (MausVar.ActModem <= ModemPorts) then
      p := MausVar.ActModem
    else
      p := 1;
    HotActivate(p);
    OthersOff(p);
  end else begin
    if ForcePort > 0 then
      OthersOff(ForcePort);
    Activate(true);
    AlleModemsAbheben;
  end;
  ModemOk := true;
end;

{=============================================================================}

function ImLimit(Phase: PhasenTyp): boolean;
begin
  ImLimit := GetTimeInt <= PhasenLimit[Phase];
end;

function DarfSenden: Boolean;
begin
  DarfSenden := GetTimeInt >= PhasenLimit[Anfang];
{  write('(',GetTimeInt,'>=',PhasenLimit[Anfang],')');}
end;

function CheckAnswer(var B: Box): Boolean;
var
  z               : string[50];
  i               : Integer;
  PasswordGot     : string[8];

  function SequenzOk(pos: byte): boolean;
  var
    s             : string[3];
    v,c,p         : string[2];
    v1,v2         : byte;
    i,len         : byte;
    err           : integer;
    MeineCrc,SeineCrc: word;
  begin
    { writeln(log, 'Init >', z, '<'); }
    SequenzOk := false;
    v := copy(z, pos + length(InitString) + 3, 2); { evtl. VersNr }
    s := copy(z, pos + length(InitString)    , 3); { Krzel }
    { writeln(log,'Seine Vers:',ord(v[1]),'.',ord(v[2])); }
    SeineVersNr := '';
    if length(v)=2 then begin
      v1 := ord(v[1]);
      v2 := ord(v[2]);
      if (v1>=1) and (v1<=9) and (v2<=99) then
        SeineVersNr := IntToStr(v1)+'.'+FormatStr(v2);
    end;
    len := length(InitString) + 5;
    ErwartePackzeit := 0;
    PasswordGot := '';
    if pos > 1 then begin
      len := ord(z[pos-1]);
      if len > length(InitString) + 5 then begin
        p := Copy(z, pos + length(InitString) + 5, 2);
        ErwartePackzeit := ord(p[1]) + ord(p[2]) shl 8;
        if SeineVersNr >= '1.91' then begin
          if len > length(InitString) + 7 then
            PasswordGot := Copy(z, pos + length(InitString) + 7, 8);
        end;
      end;
    end;
    {--- crc berprfen }
    c := copy(z, pos + len, 2); { evtl. crc }
    MeineCrc := CalcCrc(z[pos], len);
    if length(c)=2 then
      SeineCrc := ord(c[1]) + word(ord(c[2]))*256
    else
      SeineCrc := 0;
    if MeineCrc<>SeineCrc then begin
      writeln(log,'SeineCrc ',SeineCrc,' <> MeineCrc ',MeineCrc);
      exit;
    end;
    if s[1] <= '9' then begin
      { Krzel lnger 3 Zeichen }
      val(s, B, err);
      if err = 0 then begin
        SequenzOk := true;
        exit;
      end;
    end else begin
      while s[length(s)]='-'  do dec(s[0]);
      for i := 1 to MaxBoxen do begin
        if Boxen^[i].Kuerzel = s then begin
          B := i;
          SequenzOk := true;
          exit;
        end;
      end;
    end;
    write(log, 'MAUS ' + s + ' ?');
    ClearInput;
  end;

begin { CheckAnswer }
  CheckAnswer := false;
  {--- teste auf InitString gefolgt von BoxKuerzel, evtl. VersNr, evtl. crc }
  i := 0;
  while GotInput and (i < 50) do begin
    if not Carrier then begin
      write(log,'!Carrier wech!');
      exit;
    end;
    inc(i);
    z[i] := rawgetchr;
  end;
  ClearInput;
  z[0] := chr(i);
  repeat
    i := pos(InitString, z);
    if i=0 then exit;
    if SequenzOk(i) then begin
      {--- Initsequenz in Ordnung - nun Password-Check }
      if (Password[Boxen^[B].Direct] <> PasswordGot) then
        SysopLog('Password' + Boxen^[B].Kuerzel + ' <> ' + PasswordGot)
      else
        CheckAnswer := true;
      exit;
    end;
    { fr zweiten Versuch: }
    delete(z, 1, i);
  until false;
end;

procedure SendInit(add: string);
(* Format der Initsequenz
   len k @ b . y A C - VersNr {PackZeit-Password} CRC
    0  1 2 3 4 5 6 7 8 9  10    11 12    13..20   . .
*)
var
  s: string[30];
  BoxStr: string[5];
  crc: word;
begin
  writeln(log, 'Init-Sequenz');
  { writeln(log,'Meine Vers:',ord(VersStr[1]),'.',ord(VersStr[2])); }
  if length(Boxen^[ThisBox].Kuerzel) <= 3 then
    BoxStr := copyL(Boxen^[ThisBox].Kuerzel+'--',3)
  else { Krzel lnger 3 Zeichen }
    BoxStr := RCopy('00' + IntToStr(ThisBox), 3);
  s := InitString + BoxStr + VersStr + Add;
  crc := CalcCrc(s[1], length(s));
  s := s[0] + s + chr(lo(crc)) + chr(hi(crc));
  RawSendStr(s);
  RawSendStr(s);
end;

procedure WriteVerbindungMit(B: Box);
begin
  write(log, 'Verbindung mit MAUS ', BoxName(B));
  if SeineVersNr<>'' then
    write(log,', MausNet Version ', SeineVersNr);
  if Password[Boxen^[B].Direct] <> '' then
    write(log,', Password geprft');
  writeln(log);
end;

function SendBlock(var Block: NetBlock; typ: tBlock): boolean;
var
  ok: boolean;
begin
  write(log,'SendBlock: ');
  Block.typ := typ;
  ok := SendNetBlock(Block);
  writeln(log, ok);
  SendBlock := ok;
end;

function ReceiveBlock(var Block: NetBlock; typ: tBlock): boolean;
var
  ok: boolean;
begin
  write(log,'ReceiveBlock: ');
  ok := ReceiveNetBlock(Block) and (Block.typ=typ);
  writeln(log, ok);
  ReceiveBlock := ok;
end;

function NetKommunikation(B: Box; sender: boolean): boolean;
var
  MeinBlock, DeinBlock {Blcke sind fr uns alle da}: NetBlock;
  diff: SecondInt;
  s: string[80];
  ok: boolean;
  db: DirectBox;

  function CheckPackerProt(B: Box; var ich, er: NetBlock): boolean;
  begin
    CheckPackerProt := false;
    if ich.Packer<>er.Packer then begin
      SysopLog('Packer inkompatibel - ' + BoxName(ThisBox) + ':' + ich.Packer
                + ' <> ' + BoxName(B) + ':' + er.Packer);
    end else begin
      if ich.Prot<>er.Prot then begin
        SysopLog('Protokoll inkompatibel - ' + BoxName(ThisBox) + ':' + ich.Prot
                  + ' <> ' + BoxName(B) + ':' + er.Prot);
        ich.Prot := 'Z'; { Fallback auf ZModem }
      end;
      CheckPackerProt := true;
    end;
  end;

begin { NetKommunikation }
  NetKommunikation := false;
  UhrAbgleich := false;
  InitNetBlocks;
  with MeinBlock do begin
    date := GetDateInt;
    if Funkuhr then
      time := -GetSecondInt
    else
      time := GetSecondInt;
    if sender then begin
      if not SendBlock(MeinBlock, tDatum) then exit; { zuerst der Anrufer }
      if not ReceiveBlock(DeinBlock, tDatum) then exit;
    end else begin
      if not ReceiveBlock(DeinBlock, tDatum) then exit;
      if not SendBlock(MeinBlock, tDatum) then exit;
    end;
    if DeinBlock.Time < 0 then begin
      UhrAbgleich := true;
      DeinBlock.Time := -DeinBlock.Time;
    end;
    if time < 0 then time := -time;
    writeln(log,'Uhrzeit in ',BoxName(ThisBox),': ',IntToSecond(time),', in ',
            BoxName(B),': ',IntToSecond(DeinBlock.time));
    if date<>DeinBlock.date then begin
      SysopLog('Datum verschieden!!');
      UhrAbgleich := false;
    end;
    diff := time - DeinBlock.time;
    FunkuhrDiff := diff; { nach Ende der Verbindung entsprechend justieren }
    if abs(diff) > 120 then begin
      s := 'Unsere Uhr geht im Vergleich zur MAUS '+BoxName(B)+' '
          + IntToStr(abs(diff)) + ' Sekunden ';
      if diff>0 then s:=s+'vor.'
        else s:=s+'nach.';
      SysopLog(s);
      if (not Funkuhr) and (abs(diff) > 180) then
        SysopLog('Bitte UNBEDINGT berprfen!');
    end else if Funkuhr and UhrAbgleich and (abs(diff) > 15) then begin
      s := 'Funkuhr-Differenz! Unsere Uhr geht im Vergleich zur MAUS '+BoxName(B)+' '
          + IntToStr(abs(diff))+ ' Sekunden ';
      if diff>0 then s:=s+'vor!'
        else s:=s+'nach!';
      SysopLog(s);
    end;
  end;

  {--- Protokoll aushandeln }
  with ich do begin
    Packer := 'Z';
    db := Boxen^[B].Direct;
    Prot := BoxProto[db];
  end;
  if sender then
    ok := SendBlock(ich, tProt) and ReceiveBlock(er, tProt) {Short Circuit!}
  else
    ok := ReceiveBlock(er, tProt) and SendBlock(ich, tProt);
  if not ok then exit;
  if not CheckPackerProt(B, ich, er) then exit;
  NetKommunikation := true;
end;

procedure AnrufEnde;
var
  DosHour, DosMin, DosSec, DosHun: word;
  ActTime: SecondInt;
  tx: tListe;
begin
  Auflegen; { nur diese Verbindung }
  if (not Funkuhr) and UhrAbgleich then begin
    if (abs(FunkuhrDiff) < UhrAbgleichMax) then begin
      {--- so, jetzt Uhr stellen }
      dos.GetTime(DosHour, DosMin, DosSec, DosHun);
      writeln(log, 'Uhrzeit vorher : ',FormatStr(DosHour),':',FormatStr(DosMin),':',FormatStr(DosSec));
      ActTime := GetSecondInt;
      if (ActTime >= 86399) then exit;
      dec(ActTime, FunkuhrDiff); { FunkuhrDiff pos. = wir gehen voraus }
      if (NetMode = Nachtnetz) then begin
        {--- Timing-Infos ebenfalls abgleichen }
        tx := AEx;
        repeat
          if tim.t[tx] > 0 then dec(tim.t[tx], FunkuhrDiff);
          inc(tx);
        until tx = ENU;
      end;
      if (ActTime < 0) or (ActTime > 86399) then exit;
      DosSec := ActTime mod 60;
      DosMin := (ActTime div 60) mod 60;
      DosHour := ActTime div 3600;
      DosHun := 0;
      writeln(log, 'Uhrzeit nachher: ',FormatStr(DosHour),':',FormatStr(DosMin),':',FormatStr(DosSec));
      dos.SetTime(DosHour, DosMin, DosSec, DosHun);
      { fr ein MausNet /2 oder das Abendnetz merken }
      Mausvar.UhrGestelltAm := GetDateInt;
      Mausvar.UhrGestelltUm := GetTimeInt;
      WriteMausVar;
      Funkuhr := true; { wir haben jetzt Funkuhr-Zeit !!! }
      if FunkuhrDiff > 60 then
        SysopProt('Uhr um '+ZeitSeit(FunkuhrDiff)+ ' Minuten zurckgestellt')
      else if FunkuhrDiff < -60 then
        SysopProt('Uhr um '+ZeitSeit(abs(FunkuhrDiff))+ ' Minuten vorgestellt')
    end else
      SysopProt('Uhr nicht gestellt. Abweichung um '+ZeitSeit(abs(FunkuhrDiff))+' Minuten.');
  end;
end;

procedure SendRcvFile(B: Box; Sender: boolean; var SOk, ROk: boolean);
var
  PackTyp: string[3];
  db: DirectBox;
  dummy: boolean;

  function Send: boolean;
  begin
    writeln(log, 'Send: ', PackFile[db]);
    ProfilerStart('Send      ');
    XMit(pSend, ich.Prot, PackFile[db], '', SOk, dummy);
    Send := SOk;
    ProfilerEnde ('Send      ');
  end;

  function Receive: boolean;
  begin
    writeln(log, 'Receive: ', GotFileName);
    ProfilerStart('Receive   ');
    XMit(pReceive, ich.Prot, '', GotFileName, dummy, ROk);
    Receive := ROk;
    ProfilerEnde ('Receive   ');
  end;

begin { SendRcvFile }
  SOk := false;
  ROk := false;
  if ich.Packer = 'A' then PackTyp := 'ARC' else PackTyp := 'ZIP';
  GotFileName := GenName(B, ThisBox) + '.' + PackTyp;
  db := Boxen^[B].Direct;
  Bidirect := BothDir and (pos(ich.Prot, ProtoBiDir) > 0);
  if Bidirect then begin
    {--- Bidirektional }
    writeln(log, 'Send: ', PackFile[db], ' & Receive: ', GotFileName);
    ProfilerStart('Send&Rcv  ');
    XMit(pBiDir, ich.Prot, PackFile[db], GotFileName, SOk, ROk);
    ProfilerEnde ('Send&Rcv  ');
  end else begin
    {--- Erst eine Richtung, dann evtl. die andere }
    if Sender then SOk := Send
      else ROk := Receive;
    if BothDir and (SOk or ROk) then begin
      if Sender then begin
        if ReceiveBlock(er, tProt) and SendBlock(ich, tProt) then
          ROk := Receive
      end else begin
        if SendBlock(ich, tProt) and ReceiveBlock(er, tProt) then
          SOk := Send;
      end;
    end;
  end;
  AnrufEnde;

  if SOk then
    DeleteExportFiles(db, PackFile[db])
end;

function PackeExport(B: Box): boolean;
var
  Packer: char;
  db: DirectBox;
  Frei: LongInt;
  PackZeit: word;
begin
  ProfilerStart('Packen');
  Packer := 'Z';
  db := Boxen^[B].Direct;
  PackZeit := 0; { wirklich packen }
  PackeExport := PackeExportFiles(db, Packer, PackFile[db], PackZeit);
  Frei := DiskFree(0) div 1024;
  if Frei < MinFree then MinFree := Frei;
  ProfilerEnde ('Packen');
end;

function GetPackZeit(B: Box): word;
var
  Packer: char;
  db: DirectBox;
  PackZeit: word;
begin
  Packer := 'Z';
  db := Boxen^[B].Direct;
  PackZeit := 1; { nur Zeitbedarf ermitteln }
  if PackeExportFiles(db, Packer, PackFile[db], PackZeit) then;
  GetPackZeit := PackZeit;
end;

function VerbindungZu(B: Box): VerbindungsStatus;
var
  CRs,
  Schrott,
  i               : Integer;
  AnswerOK        : Boolean;
  CB,
  LastB           : Box;
  db              : DirectBox;
  ch              : Char;
  chars           : string[50];
  Uebernahme      : boolean;
begin
  write('/Zu/');
  VerbindungZu := vNotOk;
  db := Boxen^[B].Direct;
  Uebernahme := false;
  Delay(500);
  ClearInput;
  SetTimeOut(15);
  CRs := 0; Schrott := 0; chars := '';
  write(log, 'Warte auf CR,');
  while Carrier and (CRs < 5) and (not TimeOut) do begin
    if GotInput then begin
      ch := upcase(rawgetchr);
      if ch = #$0D then begin
        inc(CRs); write(log, 'CR');
      end
      else begin
        CRs := 0; inc(Schrott);
        if ch >= ' ' then begin
          chars := chars + ch;
          if length(chars) > sizeof(chars) - 10 then
            delete(chars, 1, 10);
          if (pos('MAUS', chars) > 0) or (pos('BENUTZER', chars) > 0) then
              begin
            writeln(log);
            writeln(log, 'MAUS (!) erreicht: "', chars, '"');
            {--- ansonsten versuchen wir mal eine Verbindungs-bernahme }
            if not Uebernahme then begin
              {--- aber nur einmal Inits rausschicken }
              writeln(log, 'Verbindungs-bernahme startet:');
              Uebernahme := true;
              {--- n* InitString raus -> MAUS startet ber Batch MausNet }
              for i := 1 to InitToMAUSCount do begin
                write(log, 'Init ');
                RawSendStr(InitString); delay(InitToMAUSDelay);
              end;
              SetTimeOut(20); { n Sekunden bis das MausNet luft }
              writeln(log,' weiter warten auf CRs vom MausNet.');
            end;
            chars := '';
            ClearInput;
          end;
        end;
      end;
    end;
  end;
  if CRs < 5 then begin
    write(log, 'Nicht 5 CRs, sondern ');
    if not Carrier then writeln(log, 'Carrier verloren')
    else if TimeOut then writeln(log, 'TimeOut')
    else writeln(log, Schrott, '* Schrott');
    exit;
  end;
  write(log, ' = 5 CRs,');
  i := 0;
  LastB := 0;
  SetTimeOut(10);
  repeat
    if Password[db] <> '' then
      SendInit(#0#0 + Password[db])
    else
      SendInit('');
    Delay(InitToNetDelay);
    AnswerOK := CheckAnswer(CB);
    if AnswerOK then begin
      WriteVerbindungMit(CB);
      if CB <> B then begin
        { "falsche" MAUS erreicht = Maus falsch konfiguriert }
        if CB = LastB then begin
          write(log, 'MausNet in ', BoxName(B), ' falsch konfiguriert!');
          VerbindungZu := vMaus;
          exit;
        end;
        LastB := CB;
        AnswerOK := false;
      end;
    end;
  until TimeOut or (not Carrier) or AnswerOK;
  if not AnswerOK then begin
    exit;
  end;

  if ErwartePackZeit > 0 then begin
    writeln(log, 'Erwartete Packzeit: ', ZeitSeit(ErwartePackzeit));
    if ErwartePackzeit > WarteAufPacken then begin
      write(log, 'Zu lange');
      VerbindungZu := vNotOk;
      exit;
    end;
    CRs := 0;
    { ClearInput; }
    SetTimeOut(WarteAufPacken);
    write(log, 'Warte auf CRs (evtl. Packer-Aufruf),');
    while Carrier and (CRs < 5) and (not TimeOut) do begin
      if GotInput then begin
        ch := upcase(rawgetchr);
        if ch = #$0D then begin
          inc(CRs); write(log, 'CR');
        end else CRs := 0;
      end;
    end;
    if CRs < 5 then begin
      writeln(log);
      write(log,'Keine 5 CRs');
      VerbindungZu := vNotOk; { Packen dauert zu lange - nochmal anrufen }
      exit;
    end;
    write(log, '= 5 CRs,');
    { ab jetzt luft alles normal (hoffentlich) }
  end;

  {--- MausNet-Kommunikation }
  if not NetKommunikation(B, true) then exit;

  {--- Protokoll-bertragung startet }
  SendRcvFile(B, true, SendOk, RcvOk); { evtl. gleich mit Receive }
  if not SendOk then exit;
  if BothDir and (not RcvOk) then
    exit;
  VerbindungZu := vOk;
  writeln(log, '*** Anruf zu MAUS ', BoxName(B), ' OK !')
end;

function VerbindungVon(var B: Box): VerbindungsStatus;
var
  AnswerOK        : Boolean;
  CB              : Box;
  db              : DirectBox;
  Unerwartet      : Boolean;
  CRanz           : integer;
  add             : string[10];
  Packzeit        : word;
begin
  write('/Von/');
  if NetMode <> VerbindungUebernehmen then Delay(2000);
  ClearInput;
  VerbindungVon := vNotOk;
  AnswerOK := false;
  CRanz := 0;
  repeat
    write(log, 'CRs,');
    inc(CRanz);
    RawSendStr(#$D#$D#$D#$D#$D#$D#$D#$D#$D#$D);
    if Carrier then begin
      Delay(1000);
      AnswerOK := CheckAnswer(B);
      if AnswerOK then WriteVerbindungMit(B);
    end;
  until AnswerOK or (not Carrier) or (CRanz>=7);
  Unerwartet := false;
  if AnswerOK then begin
    AnswerOK := B in nochAnrufVon;
    if (not AnswerOk) and (NetMode <> Nachtnetz) then
      { im manuellen MausNet alle Anrufer akzeptieren }
      Unerwartet := B in AnUnsDran;
  end;
  if (not AnswerOK) and (not Unerwartet) then begin
    B:=0; exit;
  end;
  SetTimeOut(10);
  add := '';
  if ((NetMode = VerbindungUebernehmen) or Unerwartet) then begin
    {--- noch nicht gepackt: voraussichtliche Packzeit bermitteln }
    PackZeit := GetPackZeit(B);
    writeln(log, 'Sende Packzeit: ', ZeitSeit(PackZeit));
    if PackZeit > 0 then
      add := chr(lo(Packzeit)) + chr(hi(Packzeit));
  end else
    PackZeit := 0;
  db := Boxen^[B].Direct;
  repeat
    if Password[db] <> '' then begin
      if add = '' then add := #0#0;
      SendInit(add + Password[db])
    end else
      SendInit(add);
    if not Carrier then
      exit;
    Delay(1000);
    AnswerOK := CheckAnswer(CB);
    if not Carrier then
      exit;
    if AnswerOK then
      writeln(log, 'Init nochmal - von MAUS ', BoxName(CB));
  until TimeOut or (not AnswerOK);
  if AnswerOK then begin
    write(log, 'Zu oft InitStr,');
    exit;
  end;

  if PackZeit > 0 then begin
  { (NetMode = VerbindungUebernehmen) or Unerwartet then begin }
    if PackeExport(B) then; { RETURN: true = nicht leer, ist aber egal }
    delay(1000);
    RawSendStr(#$D#$D#$D#$D#$D#$D#$D#$D#$D#$D);
    { als Erkennung fr den Anrufer, da Packer fertig }
  end;

  {--- MausNet-Kommunikation }
  if not NetKommunikation(B, false) then exit;

  {--- Protokoll-bertragung }
  SendRcvFile(B, false, SendOk, RcvOk);
  if not RcvOk then exit;
  if BothDir and (not SendOk) then
    exit;
  VerbindungVon := vOk;
  writeln(log);
  writeln(log, '*** Anruf von MAUS ', BoxName(B), ' OK !');
end;

procedure VersucheAnruf(B: Box);
var
  Status          : AnrufStatus;
  Baud            : Word;
  vStatus         : VerbindungsStatus;
  db              : DirectBox;
  ZusatzTxt       : string;
begin
  if ForcePort = 0 then AlleAuflegen else Auflegen;
  db := Boxen^[B].Direct;
  if ForcePort > 0 then
    SetModem(ForcePort)
  else
    SetModem(OnModem[db]);
  { Modem^.DialPost := ''; DialPost[db];}
  Modem^.DialPre := DialPre[db];
  writeln(log);
  write(log, 'Anwahl von MAUS ', BoxName(B), ',');
  Status := Anrufen(DialNumber[db]);
  VDate := GetDateInt; VTime := GetTimeInt;
  RcvOk := false; SendOk := false;
  SendRecs := 0; SendCps := 0;
  RcvRecs := 0; RcvCps := 0;
  case Status of
    aOk:
      begin
        writeln(log);
        writeln(log, 'CONNECT: ', MausConnect);
        if (MausBaud < MinBaud[db]) then begin
          Auflegen;
          SysopLog(BoxName(B)+': nur '+IntToStr(MausBaud)+
                   ' Baud. Verbindung abgebrochen.');
          vStatus := vNotOk;
          StopUhr(false); { sicherheitshalber IMMER }
          GetModemStatus;
        end else begin
          ProfilerStart('Verbind.Zu');
          vStatus := VerbindungZu(B);
          ProfilerEnde ('Verbind.Zu');
          Auflegen;
          StopUhr(false); { sicherheitshalber IMMER }
          GetModemStatus;
          if RcvOk then begin
            delay(500);
            Abheben;
            VerteileEmpfangeneDaten(B);
            GepacktIst := [];
          end;
          if not SendOk then begin
            if vStatus = vMaus then
              inc(Fehler[B], FehlerZuTeuer) { das IST zu teuer }
            else
              inc(Fehler[B], FehlerVerbindung);
            writeln(log);
            write(log, 'Anruf-Err: keine Netz-Verbindung,');
          end;
        end;
      end;
    else
      begin
        writeln(log);
        write(log, 'Anruf-Err: ', LastResponse {AnrufStatTxt[Status]}, ', ');
        inc(Fehler[B], FehlerKosten[Status]);
      end;
  end;
  writeln(log, 'Fehlerkosten: ', Fehler[B], '%');
  if Status = aOk then begin
    if BothDir and SendOk then
      vStatus := vOk; { nur Hinrichtung erfolgreich -> fertig }
    ReportStart('Anruf zur', B, LogSecs);
    CostLog(OutLog, 'Daten -> MAUS ',B,vDate,vTime,vStatus,LogSecs, SendRecs,SendCps);
    if RcvOk then
      CostLog(InLog ,'Daten <- MAUS ',B,vDate,vTime,vStatus, 0      ,RcvRecs,RcvCps);
    if BiDirect and SendOk and RcvOk then
      CostLog(NoLog ,'Daten <> MAUS ',B,0    , 0   ,vStatus, 0      ,AllRecs,AllCps);
    ZusatzTxt := '';
    if vStatus = vOk then begin
      nochAnrufen := nochAnrufen - [B];
      if BothDir and (not RcvOk) then
        ZusatzTxt := 'Empfang von Msgs gescheitert!';
    end;
    ReportEnde(vStatus, ZusatzTxt);
  end;
  if Fehler[B] >= FehlerZuTeuer then begin
    nochAnrufen := nochAnrufen - [B];
    writeln(log);
    SysopLog('MAUS '+BoxName(B)+' nicht erreicht!');
  end;
end;

procedure ErwarteAnruf(AnrufVon: BoxSet; MaxWait: Word);
var
  AnrufOk         : Boolean;
  vStatus         : VerbindungsStatus;
  B               : Box;
  ch              : char;
  p               : integer;
  TStart          : SecondInt;
  Mixed           : boolean;
  Abbruch         : boolean;
  Event           : word;

  procedure UserAbwimmeln;
  var
    f: text;
    s: string;
  begin
    RawSendStr(#$D#$A#$D#$A#$D#$A#$D#$A'MAUS ' + Boxen^[ThisBox].Kuerzel +
               ' - Zugang momentan gesperrt - MausNet luft'#$D#$A#$D#$A);
    if AbwimmelFile <> '' then begin
      {$I-}
      assign(f, AbwimmelFile);
      reset(f);
      {$I+}
      if IOresult <> 0 then begin
        SysopLog('AbwimmelFile ' + AbwimmelFile + ' nicht gefunden.');
        AbwimmelFile := '';
      end else begin
        repeat
          readln(f, s);
          RawSendStr(s);
          RawSendStr(#$D#$A);
        until eof(f);
        close(f);
      end;
    end;
    if AbwimmelFile = '' then begin
      if NetMode <> Nachtnetz then begin
        RawSendStr('Hallo WerDaAuchImmerHierAnruft,'#$D#$A);
        RawSendStr('sorry, z.Zt. laeuft das manuelle MausNet! Bitte einige Zeit nicht anrufen.'#$D#$A);
      end
      else begin
        RawSendStr('MausNet laeuft, bitte rufen Sie'#$D#$A);
        RawSendStr('nach 05:00 Uhr wieder an!'#$D#$A);
      end;
    end;
    write(log, 'User abgewimmelt,');
    Delay(3000); { um den Modembuffer leeren zu knnen }
  end;

  procedure SetModemOn;
  var
    B: Box;
    db: DirectBox;
    sum: array[1..MaxModems] of word;
  begin
    if not DualLine then begin
      if ModemPorts > 1 then begin
        FillChar(sum, sizeof(sum), 0);
        for B := 1 to maxBoxen do begin
          if B in AnrufVon then begin
            db := Boxen^[b].Direct;
            inc(Sum[OnModem[db]]);
          end;
        end;
        if (Sum[2] > 0) and (Sum[1] = 0) then
          SetModem(2)
        else
          SetModem(1);
        Mixed := false{(Sum[1] > 0 ) and (Sum[2] > 0)}
      end else
        Mixed := false;
    end else
      Mixed := (ModemPorts > 1) and (ForcePort = 0);
    if ForcePort > 0 then begin
      SetModem(ForcePort);
      if DualLine then AndereModemsAbheben;
    end;
  end;

begin {ErwarteAnruf}
  if NetMode<>VerbindungUebernehmen then begin
    ProfilerStart('ErwarteA');
    SetModemOn;
    if ForcePort = 0 then
      AlleAuflegen
    else
      Auflegen;
    SetTimeOut(MaxWait);
    repeat
      Delay(1000);
      write('W');
      PollModem;
      if keypressed then begin
        ch := upcase(ReadKey);
        if ch = 'S' then
          {--- Sound On/Off }
          ToggleSound;
      end;
      Abbruch := AnrufDa or TimeOut;
      if not Abbruch then
       if mixed then { auf anderem Modem horchen }
        SetModem(3 - ActModem);
    until Abbruch;
    ProfilerEnde ('ErwarteA');
    if not AnrufDa then
      exit;
    AnrufOk := AnrufAnnehmen(Event);
    if not AnrufOk then exit;
  end;
  writeln(log);
  writeln(log, 'CONNECT: ', MausConnect);
  VDate := GetDateInt; VTime := GetTimeInt;
  SendOk := false; RcvOk := false;
  SendRecs := 0; SendCps := 0;
  RcvRecs := 0; RcvCps := 0;
  TStart := GetSecondInt;
  ProfilerStart('VerbindVon');
  vStatus := VerbindungVon(B);
  ProfilerEnde ('VerbindVon');
  if B > 0 then begin
    if NetMode = VerbindungUebernehmen then
      ReportStart('Anrufbernahme von', B, LogSecs)
    else
      ReportStart('Anruf von', B, LogSecs);
    if BothDir and RcvOk then
      vStatus := vOk; { nur Hinrichtung erfolgreich -> fertig }
    CostLog(InLog, 'Daten <- MAUS ',B,vDate, vTime, vStatus,LogSecs,RcvRecs ,RcvCps);
    if SendOk then
      CostLog(OutLog,'Daten -> MAUS ',B,vDate, vTime, vStatus,0      ,SendRecs,SendCps);
    if BiDirect and SendOk and RcvOk then
      CostLog(NoLog, 'Daten <> MAUS ',B,0    , 0    , vStatus, 0      ,AllRecs,AllCps);
    ReportEnde(vStatus, '');
  end;
  if vStatus = vOk then begin
    if (NetMode = Nachtnetz) and (B = ServerBox) then begin
      tim.t[AVO] := tStart;
      tim.t[EVO] := GetSecondInt;
      tim.Recs := RcvRecs;
      tim.cps := RcvCps;
    end;
    StopUhr(false); { sicherheitshalber IMMER }
    GetModemStatus;
    Abheben;
    nochAnrufVon := nochAnrufVon - [B];
    if NetMode = VerbindungUebernehmen then
      InitMsgFiles; { Msg-Index, ExportFiles etc. }
    VerteileEmpfangeneDaten(B);
    GepacktIst := [];
    AlleAuflegen;
    IchWarteSeit := GetSecondInt;
  end else begin
    if Carrier then
      UserAbwimmeln;
    AlleAuflegen;
    StopUhr(false); { sicherheitshalber IMMER }
    GetModemStatus;
  end;
end;

procedure CheckGepacktIst(B: Box);
var
  ok: boolean;
begin
  if not (B in GepacktIst) then begin
    ok := (GetPackZeit(B) = 0);
    if not ok then begin
      Abheben;
      ok := PackeExport(B);
      AlleAuflegen;
    end;
    if ok then
      GepacktIst := GepacktIst + [B]
    else { war nichts da zum Packen / Packer tat's nicht }
      if NetMode = Nachtnetz then
        NochAnrufen := NochAnrufen - [B];
  end;
end;

procedure MacheAlleAnrufe(Phase: PhasenTyp);
var
  B               : Box;
  ZeitOk          : Boolean;
  BoxRangDran,
  BoxRangMax      : integer;
begin
  ProfilerStart('MacheAnruf');
  write(log, 'Zeit-Limit:  - ',ZeitSeit(PhasenLimit[Phase]));
  writeln(log, '. Es ist ', GetTime);
  if not DarfSenden then begin
    write(log, 'darf noch nicht senden,');
    while not DarfSenden do begin
      write(GetTime, ',');
      SetModem(1); { immer auf Default-Modem }
      ErwarteAnruf([], 30);
    end;
    write(log, 'darf senden (!),');
  end;
  nochAnrufen := [];
  for B := 1 to maxBoxen do begin
    with Boxen^[B] do begin
      if ((Phase=NachOben) and Uebermir)
      or ((Phase=NachUnten) and Untermir) then begin
        if (not FremdBox) and (AllTrim(Nummer1)<>'0') then
          nochAnrufen := nochAnrufen + [B];
      end;
    end;
  end;
  nochAnrufen := nochAnrufen - DontCall;
  GepacktIst := [];
  BoxRangDran := 0;
  BoxRangMax := min(2, MaxDirectBox); { 1,2, 1,2,3, 1,2,3,4 }
  if ImLimit(Phase) then begin
    while (nochAnrufen <> []) and (ImLimit(Phase)) do begin
      repeat { nochAnrufen <> [] !! }
        if BoxRangDran >= BoxRangMax then begin
          BoxRangDran := 1;
          if BoxRangMax < MaxDirectBox then inc(BoxRangMax);
        end else
          inc(BoxRangDran);
        B := CallOrder[BoxRangDran];
      until B in nochAnrufen;
      CheckGepacktIst(B);
      if (tim.t[EPa] = 0) and (Phase = NachOben) then
        tim.t[EPa] := GetSecondInt;
      if B in NochAnrufen then begin
        VersucheAnruf(B);
        write(GetTime, ',');
        SetModem(1);
        ErwarteAnruf([], CallDelay);
        { nur User (oder falschge"time"te Muse) abwimmeln ! }
      end;
    end;
    if NochAnrufen <> [] then
      SysopProt('Keine Verbindung zu MAUS '
               + BoxList(NochAnrufen) + ' bekommen!');
  end;
  SysopProt('');
  ProfilerEnde ('MacheAnruf');
end;

procedure HoleAlleAnrufe(Phase: PhasenTyp);
var
  B               : Box;
  ZeitOk,first    : Boolean;
  s               : string;
begin
  ProfilerStart('HoleAlleAnrufe');
  write(log, 'Zeit-Limit:  - ',ZeitSeit(PhasenLimit[Phase]));
  writeln(log, '. Es ist ', GetTime);
  nochAnrufVon := [];
  for B := 1 to maxBoxen do
    if not Boxen^[B].FremdBox then
    if ((Phase=VonUnten) and Boxen^[B].untermir)
    or ((Phase=VonOben) and Boxen^[B].uebermir) then begin
      nochAnrufVon := nochAnrufVon + [B];
    end;
  if ImLimit(Phase) then begin
    IchWarteSeit := GetSecondInt;
    while (NochAnrufVon-DontWaitFor <> []) and ImLimit(Phase) do begin
      write(GetTime, ',');
      ErwarteAnruf(NochAnrufVon-DontWaitFor, 30);
    end;
    if NochAnrufVon-DontWaitFor <> [] then begin
      IchWarteSeit := min(max(0,GetSecondInt-IchWarteSeit),60*60);
      s := ZeitSeit(IchWarteSeit) + ' Minuten gewartet. Kein Anruf von MAUS ';
      first := true;
      for B := 1 to MaxBoxen do begin
        if B in NochAnrufVon then begin
          if first then first:=false
            else s := s + ', ';
          s := s + BoxName(B);
        end;
      end;
      SysopProt(s+' erhalten!');
    end;
    SysopProt('');
  end;
  ProfilerEnde ('HoleAlleAnrufe');
end;

procedure MacheNachtnetz;
begin
  if GetTimeInt > PhasenLimit[NachUnten] then exit;
  if NachtModus <> Nacht2 then begin
    ProfilerStart('Phase 1-2');
    tim.t[EEx] := GetSecondInt;
    writeln(Log,'Phase 1: Anrufe von unten');
    HoleAlleAnrufe(VonUnten); { von unten }
    tim.t[EVU] := GetSecondInt;
    writeln(Log);
    writeln(Log,'Phase 2: Anrufe nach oben');
    MacheAlleAnrufe(NachOben); { nach oben }
    tim.t[ENO] := GetSecondInt;
    writeln(Log);
    ProfilerEnde('Phase 1-2');
  end;
  if NachtModus <> Nacht1 then begin
    ProfilerStart('Phase 3-4');
    writeln(Log,'Phase 3: Anrufe von oben');
    HoleAlleAnrufe(VonOben); { von oben }
    tim.t[ANU] := GetSecondInt;
    writeln(Log);
    writeln(Log,'Phase 4: Anrufe nach unten');
    MacheAlleAnrufe(NachUnten); { nach unten }
    tim.t[ENU] := GetSecondInt;
    PMStatusCheck;
    ProfilerEnde('Phase 3-4');
  end;
  TimingExit;
end;

{============================ Einzel-Verbindungen ============================}

var
  OurTimeOut, OurDate: integer;

function InitWaitTime(TimeOutZeit: integer): boolean;
{--- TRUE: bereits Timeout }
var
  OurTime: integer;
  TimeOut: boolean;
begin
  OurTime := GetTimeInt;
  OurDate := GetDateInt;
  TimeOut := false;
  if TimeOutZeit = 0 then
    OurTimeOut := OurTime + 30 { Minuten }
  else begin
    OurTimeOut := TimeOutZeit;
    if OurTimeOut < OurTime then begin
      { 24-Stunden-bertrag? }
      if OurTimeOut < OurTime - 22*60 then
        inc(OurTimeOut, 24*60)
      else { Zeit vorbei! }
        TimeOut := true;
    end else
      if OurTimeOut > OurTime + 120 then
        TimeOut := true;
  end;
  write(log, 'Zeit-Limit: - ', ZeitSeit(OurTimeOut),'. Es ist ', GetTime, '.');
  if TimeOut then write(log, ' TimeOut!');
  writeln(log);
  InitWaitTime := TimeOut;
end;

function IsTimeOut: boolean;
var
  Minute: integer;
begin
  Minute := (GetDateInt - OurDate) * 24*60 + GetTimeInt;
  IsTimeOut := (Minute > OurTimeOut);
end;

procedure MultiVerbindungZu(ToBoxen: BoxSet; TimeOutZeit: integer);
var
  B               : Box;
  s               : string;
  first           : boolean;
begin
  if InitWaitTime(TimeOutZeit) then exit;
  NochAnrufen := ToBoxen;
  BothDir := true;
  GepacktIst := [];
  B := 0;
  first := true;
  while (nochAnrufen <> []) and (not IsTimeOut) do begin
    repeat
      inc(B);
      if B > MaxBoxen then B := 1;
    until B in nochAnrufen;
    { SetModem(1); }
    if First then begin
      {--- Am Anfang eine kleine Verzgerung, z.B. fr ein <S> }
      ErwarteAnruf([], 2);
      first := false;
    end else begin
      write(GetTime, ',');
      ErwarteAnruf([], CallDelay);
    end;
    CheckGepacktIst(B);
    VersucheAnruf(B);
    if not (B in NochAnrufen) then
      GepacktIst := []; { Anruf erfolgreich: neu packen }
  end;
  if NochAnrufen <> [] then begin
    s := 'Keine Verbindung zu MAUS ';
    first := true;
    for B := 1 to MaxBoxen do begin
      if B in NochAnrufen then begin
        if first then first:=false
          else s := s + ', ';
        s := s + BoxName(B);
      end;
    end;
    SysopProt(s+' bekommen!');
  end;
end;

procedure MultiVerbindungVon(FromBoxen: BoxSet; TimeOutZeit: integer);
var
  B               : Box;
  vorher          : BoxSet;
  TimeOut         : boolean;
begin
  if InitWaitTime(TimeOutZeit) then exit;
  nochAnrufVon := [];
  for B := 1 to maxBoxen do
    if B in AnUnsDran then begin
      if (FromBoxen = []) or (B in FromBoxen) then begin
        nochAnrufVon := nochAnrufVon + [B];
        if GetPackZeit(B) > 0 then
          if PackeExport(B) then;
      end;
    end;
  GepacktIst := NochAnrufVon;
  BothDir := true;
  if FromBoxen = [] then begin
    {--- erwarte einen unbestimmten Anruf }
    vorher := NochAnrufVon;
    while (nochAnrufVon = vorher) and (not IsTimeOut) do begin
      write(GetTime, ',');
      SetModem(1);
      ErwarteAnruf(NochAnrufVon, 30);
    end;
  end else begin
    {--- erwarte einen/mehrere bestimmte Anrufe }
    repeat
      vorher := nochAnrufVon;
      repeat
        write(GetTime, ',');
        ErwarteAnruf(NochAnrufVon, 30);
        TimeOut := IsTimeOut;
      until (NochAnrufVon <> vorher) or (GepacktIst <> vorher) or TimeOut;
      if not TimeOut then begin
        Abheben;
        {--- fr den Rest packen }
        for B := 1 to MaxBoxen do
          if B in NochAnrufVon then
            if PackeExport(B) then {auf jeden Fall packen};
        GepacktIst := NochAnrufVon;
        AlleAuflegen;
      end;
    until (nochAnrufVon = []) or TimeOut;
  end;
end;

procedure UebernehmeAnruf;
var
  B: Box;
begin
  StopUhr(true); { StopUhr starten }
  NochAnrufVon := AnUnsDran;
  BothDir := true;
  ErwarteAnruf(NochAnrufVon, 0);
end;

var
  ExitSave: pointer;

{$F+}
procedure ExitAnruf;
begin
  ExitProc:=ExitSave;
  writeln(log);
  if MinFree < MaxWord then begin
    writeln(log, 'Minimal frei: ', MinFree, ' KB');
    writeln(log);
  end;
  CostLogExit;
  if ModemOk then begin
    if Connected then begin
      write(Log, 'Auflegen!'); Auflegen;
      { unbedingt auflegen, falls Verbindung noch da (zB bei Runtime-Error) }
    end;
    if AmEndeAbheben then begin
      if DualLine then
        AlleModemsAbheben
      else begin
        if ActModem <> 1 then begin
          {--- anderes Modem auflegen }
          Auflegen; SetModem(1); Abheben;
        end;
      end;
    end else
      Auflegen;
    Deactivate;
  end;
end;

const
  PhasenStr : array[PhasenTyp] of string[15] =
    ('AnfangSenden','EndeVonUnten','EndeNachOben',
     'EndeVonOben','EndeNachUnten');
(* bis Version 1.67:
  PhasenDefault: array [1..5] of array[PhasenTyp] of DateStr =
{Ebene Anfang     5->4    4->3    3->2    2->1          1->2    2->3    3->4   4->5 }
({1} ('04:05',                           '04:34','','','05:20'),
 {2} ('04:05',                   '04:20','04:33',      '05:22','05:40'),
 {3} ('04:03',           '04:10','04:19',                      '05:42','06:00'),
 {4} ('04:00',   '04:05','04:09',                                      '06:02','06:15'),
 {5} ('03:55','','04:04',                                                      '06:17',''));
*)
  PhasenDefault: array [boolean, 1..5] of array[PhasenTyp] of DateStr =
{Ebene Anfang     5->4    4->3    3->2    2->1          1->2    2->3    3->4   4->5 }
(({1}('04:05',                           '04:30','','','05:25'),
  {2} ('04:05',                   '04:18','04:29',      '05:26','06:00'),
  {3} ('04:03',           '04:08','04:17',                      '06:02','06:15'),
  {4} ('04:00',   '04:05','04:07',                                      '06:16','06:30'),
  {5} ('03:55','','04:04',                                                      '06:31','')),

 ({1} ('03:15',                           '03:37','','','04:18'),
  {2} ('03:15',                   '03:28','03:36',      '04:20','04:33'),
  {3} ('03:13',           '03:19','03:27',                      '04:35','04:46'),
  {4} ('03:09',   '03:15','03:18',                                      '04:48','04:58'),
  {5} ('03:05','','03:14',                                                      '05:00','')));

(*
Jrg Stattaus schrieb:
JS>1                         03:37   04:18
JS>2 03:15             03:28 03:36   04:20 04:33
JS>3 03:13       03:19 03:27               04:35 04:46
JS>4 03:09 03:15 03:18                           04:48 04:58
JS>5 03:05 03:14                                       05:00
*)

procedure ShowLimits;
var
  p: PhasenTyp;
begin
  for p:=Anfang to NachUnten do
    writeln(log,AlignL(PhasenStr[p],14),': ',ZeitSeit(PhasenLimit[p]));
  writeln(log);
end;

procedure GetPhasenLimits;
var
  p: PhasenTyp;
  ZeitStr: DateStr;
begin
  for p:=Anfang to NachUnten do begin
    GetConfigString(ZeitStr, PhasenStr[p],'');
    if ZeitStr<>'' then
      PhasenConfig[p] := MinutenSeit(ZeitStr)
    else
      PhasenConfig[p] := 0;
  end;
end;

procedure SetPhasenLimits;
var
  p: PhasenTyp;
  ZeitStr: DateStr;
  Zeit: integer;
label
  ende;

  procedure SetDefaults;
  var
    c: PhasenTyp;
    neu: boolean;
  begin
    neu := GetDateInt >= TageSeit('16.12.95');
    for c:=Anfang to NachUnten do begin
      ZeitStr := PhasenDefault[neu, ThisLevel][c];
      if ZeitStr<>'' then
        PhasenLimit[c] := MinutenSeit(ZeitStr)
      else
        PhasenLimit[c] := PhasenLimit[pred(c)];
    end;
  end;

begin { SetPhasenLimits }
  SetDefaults;
{  ShowLimits;}
  for p:=Anfang to NachUnten do begin
    Zeit := PhasenConfig[p];
    if Zeit<>0 then
      PhasenLimit[p] := Zeit;
  end;
  for p:=VonUnten to NachUnten do
    if PhasenLimit[pred(p)] > PhasenLimit[p] then begin
      writeln(log,'Fehler: ',PhasenStr[pred(p)],' > ',PhasenStr[p],
              '. Defaults werden benutzt.',bell);
      SetDefaults;
      goto ende;
    end;
  ende:
    ShowLimits;
end;

procedure AnrufInit;
{--- wird von mnMain NACH dem ConfigEinlesen aufgerufen }
var
  b: box;
  db: DirectBox;
begin
  GetBoxConfigs;
  for b:=1 to MaxBoxen do
    if b in AnUnsDran then begin
      db := Boxen^[b].Direct;
      if ModemPorts > 1 then begin
        if ForcePort > 0 then
          OnModem[db] := ForcePort
        else
          OnModem[db] := GetConfigWord('Modem.' + BoxName(b), 1);
      end else
        OnModem[db] := 1;
      {--- Modem1|2.DialPre.AC2 }
      GetConfigString(DialPre[db], 'ModemDialPre' + BoxName(b),
                      Modems[OnModem[db]]^.DialPre);
      if ModemPorts > 1 then begin
        if ConfigOk then
          SysopLog('Bitte umstellen: Modem' + IntToStr(OnModem[db]) + '.DialPre.' + BoxName(b)
                 + ' statt ModemDialPre' + BoxName(b));
        GetConfigString(DialPre[db],
          'Modem' + IntToStr(OnModem[db]) + '.DialPre.' + BoxName(b),
                      DialPre[db]);
      end;
      {--- Modem1|2.Nummer.AC }
      GetConfigString(DialNumber[db], 'Modem.Nummer.' + BoxName(b),
                      Boxen^[b].Nummer1);
      if ModemPorts > 1 then begin
        if ConfigOk then
          SysopLog('Bitte umstellen: Modem' + IntToStr(OnModem[db]) + '.Nummer.' + BoxName(b)
                 + ' statt Modem.Nummer.' + BoxName(b));
        GetConfigString(DialNumber[db], 'Modem' + IntToStr(OnModem[db]) + '.Nummer.'
                 + BoxName(b), DialNumber[db]);
      end;
      writeln(log, 'Dial ', BoxName(b),' [Modem ', OnModem[db],
              '] AT ', DialPre[db], ' ', DialNumber[db]{, ' ', DialPost[db]});
    end;
end;

var
  FunkuhrZeitFuerMin: integer;
begin
  fillchar(Fehler, sizeof(Fehler), 0);
  FehlerKosten[aOk] := 100; { Programm spinnt }
  FehlerKosten[aNoCarrier] := GetConfigInteger('FehlerNoCarrier', 30);
  FehlerKosten[aBusy] := GetConfigInteger('FehlerBusy', 1);
  FehlerKosten[aNoDialtone] := GetConfigInteger('FehlerNoDialtone', 10);
  FehlerKosten[aNoAnswer] := GetConfigInteger('FehlerNoAnswer', 5);
  FehlerVerbindung := GetConfigInteger('FehlerVerbindung', 50);
  CallDelay := GetConfigInteger('CallDelay', 15);
  Funkuhr := GetConfigBoolean('Funkuhr', false);
  if not Funkuhr then begin
    { haben wir noch Funkuhr-Zeit? }
    FunkuhrZeitFuerMin := GetConfigInteger('FunkuhrZeitFuerMin', 60);
    Funkuhr := (MausVar.UhrGestelltAm = today)
           and (MausVar.UhrGestelltUm >= GetTimeInt - FunkuhrZeitFuerMin);
    if Funkuhr then
      writeln(log, 'Funkuhr-Zeit noch gltig.');
  end;
  InitToMAUSCount := GetConfigWord('InitToMAUSCount', 3);
  InitToMAUSDelay := GetConfigWord('InitToMAUSDelay', 250);
  InitToNetDelay := GetConfigWord('InitToNetDelay', 3000);
  UhrAbgleichMax := GetConfigWord('UhrAbgleichMax', 300);
  WarteAufPacken := max(GetConfigWord('WarteAufPacken', 60), 5);
  AmEndeAbheben := GetConfigBoolean('AmEndeAbheben',true);
  DualLine := GetConfigBoolean('DualLine', true);
  GetConfigString(AbwimmelFile, 'AbwimmelFile', '');
  GetPhasenLimits;
  MinFree := MaxWord;
  ExitSave:=ExitProc;
  ExitProc:=@ExitAnruf;
end.

