
{$M 65520,0,655360}

program mnConfig;
{$ifndef NetLog}
{$error NetLog sollte definiert sein!}
{$endif}

uses
  Dos, mnLog, m7Dec, m7UtilLo, m7Config, mnConfMa, mnDef, mnMain, m7utilg,
  m7fileio, Version  {$ifdef OS2} ,use32 {$endif};

const
  ConfigFile      : string= 'MAUSNET.CFG';
  Ver             = '2.01'
  {$ifdef DPMI}
  + '/dpmi'
  {$endif}
  {$ifdef OS2}
  + '/OS2'
  {$endif}
  {$ifdef gs}
  + '/gs'
  {$endif}
  {$ifdef js}
  + '/js'
  {$endif}
  {$ifdef kh}
  + '/kh'
  {$endif}
  {$ifdef mk}
  + '/mk'
  {$endif}
  {$ifdef fm}
  + '/fm'
  {$endif}
  ;

var
  i,
  j               : Integer;
  OldBox          : Byte;
  F               : SearchRec;
  CNFEXP          : array [0 .. 300] of string[12];
  CEno            : array [Box] of System.Word;
  sr              : SearchRec;
  D               : DirStr;
  N               : NameStr;
  E               : ExtStr;

function cce(before, after: Integer): Boolean;
begin
  cce := CNFEXP[before] <= CNFEXP[after];
end;

procedure sce(a, b: Integer);
var
  s               : string;
begin
  s := CNFEXP[a];
  CNFEXP[a] := CNFEXP[b];
  CNFEXP[b] := s;
end;

begin {mnConfig}
  if ConfigFile = '' then
    Exit;
  Close(Input); Close(Output);
  Assign(Input, ''); Assign(Output, '');
  Reset(Input); Rewrite(Output);
  ProgrammVersion(Ver);
  ProgVersion := 'MNConfig ' + Ver;
  MausVar.MNconfigVer := Ver;
  WriteLn(Log, 'MausNet-Config ', Ver);
  WriteLn(Log, '[Sourcen: MausNet ', VersNr, ' vom ', VersDat, ' / MAUS ',
      m7Dec.Version, ']');
  TestConfigOnly := True;
  Debugging := False;
  ThisKuerzel := '';
  for i := 1 to ParamCount do
    if UpStr(ParamStr(i)) = '/X' then
      TestConfigOnly := False
    else
      if UpStr(ParamStr(i)) = '/D' then
        Debugging := True
      else begin
        ThisKuerzel := ParamStr(i);
        Trim(ThisKuerzel);
        UpString(ThisKuerzel);
      end;
  DrawConfigLine('MNConfig - Routing');
  ClearConfig;
  OldBox := ThisBox;
  if ThisKuerzel <> '' then
    ThisBox := 0
  else
    if ThisBox <> 0 then
      ThisKuerzel := OldBoxen^[ThisBox].Kuerzel;
  if (ThisBox = 0) and (ThisKuerzel = '') then begin
    WriteLn(Log, 'Kann lokale Box nicht bestimmen, bitte angeben.');
    Halt;
  end;

  FillChar(CNFEXP, SizeOf(CNFEXP), 0);
  FillChar(CEno, SizeOf(CEno), $FF);
  DosError := 0;
  i := 0;
  FindFirst(ConfPath + '*.*', AnyFile, sr);
  while DosError = 0 do begin
    if (sr.Attr and (Directory or VolumeID) = 0) then begin
      FSplit(sr.Name, D, N, E);
      if (E = '.EXP') or (E = '.CNF') then begin
        CNFEXP[i] := N;
        Inc(i);
      end;
    end;
    FindNext(sr);
  end;
  if i > 0 then
    QSort(0, i - 1, cce, sce);
  for j := 1 to i - 1 do
    if CNFEXP[j] = CNFEXP[j - 1] then
      CNFEXP[j] := '';
  WriteLn(Log, '[Pass 1]');
  for j := 0 to i - 1 do
    if CNFEXP[j] <> '' then
      CEno[ReadNewConfigFile1(CNFEXP[j])] := j;

  if ThisBox = 0 then begin
    WriteLn(Log, 'Boxnummer nicht entzifferbar: ', ThisKuerzel);
    Halt(255);
  end;
  ThisKuerzel := Boxen^[ThisBox].Kuerzel;
  if (OldBox <> 0) and (ThisBox <> OldBox) then
    WriteLn(Log, 'Boxnummer gendert: alt=', OldBox, ' neu=', ThisBox,
        #7#7#7#7#7);

  WriteLn(Log, '[Pass 2]');
  if not TestConfigOnly then
    DelFile(MausNetPath + AliasFile);
  for i := 0 to $FF do
    if CEno[i] <= High(CNFEXP) then
      ReadNewConfigFile2(i, CNFEXP[CEno[i]])
    else
      ReadNewConfigFile2(i, '');

  ComputeConfig;
  CloseConfig;
  ConfigThis;
  WriteLn(Log);
  if TestConfigOnly then
    Write(Log, 'Test-')
  else
    Write(Log, 'Echte ');
  WriteLn(Log, 'MausNet-Konfiguration fr ', Boxen^[ThisBox].Name, ' (',
      Boxen^[ThisBox].Kuerzel, ') erzeugt.');
  WriteMausVar;
end {mnConfig}.