{ MNPROTO.PAS - XModem }

{$A-,B-,E-,N-,R-,S+,V-}

unit mnProto;

interface

uses
  m7utillo,m7Raw,m7rawini,mnLog,mnUtil,
  Crt,dos,m7Config,
  m7fileio,m7dec,m7time,m7utilg,m7msg,mndef,m7exec
  {$ifdef OS2} ,use32 {$endif};

var
  SendSize, RcvSize: Longint;
  SendCps, RcvCps, SendRecs, RcvRecs: LongInt;
  AllSize, AllRecs, AllCps: LongInt;
  { DszLogFile: PathStr; }
const
  NetBlockMarker = #234;
  NetAck = chr(123)+chr(not 123);
  NetNak = chr(213)+chr(not 213);
type
  ProtArt = (pSend, pReceive, pBidir);
  tBlock = (tEnde, tDatum, tProt, tAll);
  NetBlock = record
               CRC: system.word;
               len: system.word;
               seq: system.word;
               case typ: tBlock of
                 tEnde : ();
                 tDatum: (Date: system.word; Time: SecondInt);
                 tProt : (Packer: char; Prot: char);
(*
                 tAll  : (DumPack: char; DumProt: char;
                          AllDate: word; AllTime: SecondInt;
*)
             end;
const
  lEnde  = 3*sizeof(system.word) + sizeof(tBlock);
  lDatum = lEnde + sizeof(system.word) + sizeof(SecondInt);
  lProt  = lEnde + 2*sizeof(char);
  lAll   = lDatum + 2*sizeof(char);
const
  OkTxt: array[boolean] of string[10] = ('Nicht Ok', 'Ok');

procedure InitNetBlocks;
function SendNetBlock(var Block: NetBlock): boolean;
function ReceiveNetBlock(var Block: NetBlock): boolean;

function CalcCrc(var Buf; len: word): word;

procedure XMit(Prot: ProtArt; art: char {X/Z}; SendFName, RcvFName: string;
               var SendOk, RcvOk: Boolean);


implementation

var
  SndSeq, RcvSeq: word;
  DszLogFile      : PathStr;

function CalcCrc(var Buf; len: word): word;
var
  tBuf: array[0..maxint] of byte absolute Buf;
  d,
  e,
  i,
  temp            : Byte;
begin {|CalcCrc}
  d := 0; e := 0;
  for i := 0 to len-1 do begin
    temp := Ord(tbuf[i]) xor d;
    temp := (temp xor (temp shr 4)) and $FF;
    d := ((temp shl 4) xor (temp shr 3) xor e) and $FF;
    e := (temp xor (temp shl 5)) and $FF;
  end {|for i:=0 to$7F};
  CalcCrc := d shl 8 + e;
end {|CalcCrc};

function WaitforChar(Zsec: Integer): Boolean;
var
  c,
  d               : Integer;
  CharGot         : Boolean;
begin {|WaitforChar}
  if Carrier then begin
    SetTimeOut(Zsec div 10);
    repeat
    until TimeOut or GotInput;
    WaitforChar := GotInput;
  end else
    WaitForChar := false;
end {|WaitforChar};

procedure XMit(Prot: ProtArt; art: char {X/Z}; SendFName, RcvFName: string;
               var SendOk, RcvOk: Boolean);
{ ErrorCodes : 0 = OK
              -3 = mehr als ErrLim Errors
              -4 = Carrier Lost
              -5 = laut DSZ.LOG nicht ok
              -7 = Empfangsfile nicht vorhanden
              >0 = Turbo I/O Errors }
var
  Error           : integer;
  StartTime       : integer;

procedure ZModem;
var
  cmd,z: string[80];
  ProtOk: text;
  D: DirStr;
  N: NameStr;
  E: ExtStr;
begin
  {$ifndef OS2}
  cmd:='ZMODEM.BAT '+IntToStr(ModemComPort);
  {$else}
  cmd:='ZMODEM '+IntToStr(ModemComPort);      (* damit auch zmodem.cmd geht *)
  {$endif}
  case Prot of
    pSend: cmd := cmd + ' sz ';
    pReceive: cmd := cmd + ' rz ';
    pBidir: cmd := cmd + ' bi ';
  end;
  if Prot = pReceive then
    FSplit(RcvFName, D, N, E)
  else
    FSplit(SendFName, D, N, E);
  cmd := cmd + N + E;
  if NetMode = Nachtnetz then cmd := cmd + ' dsz.out'
    else cmd := cmd + ' con';
  cmd := MausNetPath + cmd + ' ' + Art + ' ' + IntToStr(MausBaud);
  cdd(NetIOPath);
  writeln(log, '<', cmd, '>');
  {$I-}
  assign(ProtOk, 'zmodem.ok');
  erase(ProtOk);
  if IoResult>0 then;
  {$I+}
  {$ifndef OS2}
  IODeaktiv;
  {$else}
  IODeaktiv(TRUE); { Unter OS2: Port schlieen! }
  {$endif}
  Exec(cmd, true, false);
  IOAktiv;

  {$I-}
  assign(ProtOk, 'zmodem.ok');
  reset(ProtOk);
  {$I+}
  if IoResult = 0 then begin
    error := 0;
    close(ProtOk);
  end else begin
    error := -3;
  end;
  cdd(MausNetPath);
end;

function AnalyseDSZLOG: boolean;
var
  bytes, Ofs: word;
  z, LogBuf, Filename: string;
  DszLog: file;

  function GetLine: string;
  var
    Ende: word;
    ch: char;
  begin
    Ende := ofs;
    repeat
      dec(ofs);
    until LogBuf[ofs] = #10;
    GetLine := Copy(LogBuf, ofs+1, ende-ofs);
  end;

  function GetWord(WordN: byte): string;
  var
    p, q, w: word;
  begin
    p := 1;
    w := 1;
    repeat
      q := p;
      while (p <= length(z)) and (z[p] <> ' ') do inc(p);
      { writeln('Word', w,':', Copy(z, q, p-q)); }
      if w = WordN then begin
        GetWord := Copy(z, q, p-q);
        exit;
      end;
      inc(w);
      while (p <= length(z)) and (z[p] = ' ') do inc(p);
    until p >= length(z);
    GetWord := '';
  end;

  procedure GetResult(var FileName: string; var Bytes: LongInt; var ok: boolean);
  (* DSZ.LOG:
  h 151470 64000 bps 7086 cps   0 errors     0 1966 MNAC-K2-.ZIP 4382
  H 1005228 64000 bps 7566 cps   0 errors     0 1708 D:\MAUS\NET\MNK2-AC-.ZIP 4382
  *)
  var
    D: DirStr;
    N: NameStr;
    E: ExtStr;
    ByteStr: string[10];
    i, err: integer;
    Result: char;
  label
    Error;
  begin
    z := GetLine;
    Result := z[1];
    ByteStr := GetWord(2);
    val(ByteStr, Bytes, err);
    if err > 0 then goto Error;
    FileName := GetWord(11);
    if FileName = '' then goto Error;
    for i := 1 to length(FileName) do { DSZ-Fix: }
      if FileName[i] = '/' then FileName[i] := '\';
    FSplit(FileName, D, N, E);
    FileName := UpStr(N + E);
    ok := not (upcase(Result) in ['E','L']);
    exit;

    error:
      SysopLog(DszLogFile + ': Format inkompatibel');
  end;

  function AnalyseLine: boolean;
  { setzt RcvOk, SendOk. Return TRUE, wenn eine Zeile gefunden }
  var
    FName: string;
    FSize: LongInt;
    FOk, Ok: boolean;
    D: DirStr;
    N: NameStr;
    E: ExtStr;
  begin
    GetResult(FName, FSize, FOk);
    writeln(log, '<DSZ.LOG:', FName, ':', FSize, ':', FOk, '>');
    AnalyseLine := true;
    if Prot <> pReceive then begin
      FSplit(SendFName, D, N, E);
      Ok := FName = N+E;
      writeln(log, 'DSZLOG> SendOk? ', Ok, ' := ', FOk);
      if Ok then begin
        SendOk := FOk {and (FSize = SendSize)};
        exit;
      end;
    end;
    if Prot <> pSend then begin
      FSplit(RcvFName, D, N, E);
      Ok := FName = N+E;
      writeln(log, 'DSZLOG> RcvOk? ', Ok, ' := ', FOk);
      if Ok then
        RcvOk := FOk {and (FSize = RcvSize)};
    end;
    AnalyseLine := Ok;
  end;

var
  Ok: boolean;
  ft: longint;
  dt: tDateTime;
  DszDate, DszTime: word;
begin {AnalyseDSZLog}
  {$I-}
  assign(DszLog, DszLogFile);
  reset(DszLog, 1);
  {$I+}
  Ok := (IoResult = 0);
    if not ok then writeln(log, 'DSZLOG> nicht gefunden');
  if Ok then begin
    { DSZ.LOG aktuell? }
    GetFTime(DszLog, ft);
    dszdate := TageSeit(FileDateToMaus(ft));
    dsztime := MinutenSeit(FileTimeToMaus(ft));
    Ok := (dszdate = today) and (dsztime >= StartTime);
      if not ok then writeln(log, 'DSZLOG> nicht aktuell');
  end;
  if Ok then begin
    bytes := min(255, FileSize(DszLog));
    seek(DszLog, FileSize(DszLog) - bytes);
    BlockRead(DszLog, LogBuf[1], bytes);
    LogBuf[0] := chr(bytes);
    close(DszLog);
    Ofs := Bytes;
    ok := AnalyseLine;
    if (Prot = pBiDir) and ok then
      ok := AnalyseLine;
    case Prot of
      pSend   : if SendOk then Error := 0 else Error := -5;
      pReceive: if RcvOk then Error := 0 else Error := -5;
      pBiDir  : if SendOk and RcvOk then Error := 0 else Error := -5;
    end;
    writeln(log, 'DSZLOG> SendOk: ', SendOk, ' RcvOk: ', RcvOk, '>');
    AnalyseDSZLOG := true;
  end else begin
    SysopLog(DszLogFile + ' nicht ok');
    AnalyseDSZLOG := false;
  end;
end;

var
  StopUhrStart, StopUhrZeit: LongInt;
  f: file;
  RcvFt: longint;
  FileRcvd: boolean;
label
  Leave;
begin {XMit}
  ClearInput;
  StopUhrStart := GetSec100;
  StartTime := GetTimeInt;
  SendOk := false; RcvOk := false;
  RcvSize := 0;
  SendSize := 0;
  SendOk := false;
  RcvOk := false;
  FileRcvd := false;
  if Prot <> pReceive then begin
    assign(f, SendFName);
    {$I-}
    reset(f, 1);
    {$I+}
    Error := ioresult;
    if Error <> 0 then
      goto Leave;
    SendSize := FileSize(f);
    close(f);
  end;

  ZModem;
  if Prot <> pSend then begin
    assign(f, RcvFName);
    {$I-} reset(f, 1); {$I+}
    if IoResult = 0 then begin
      RcvSize := FileSize(f);
      GetFTime(f, RcvFt);
      FileRcvd := (RcvSize > 0) and (RcvFt > 0);
      RcvOk := FileRcvd;
        { verdachtsweise immer true, wenn was empfangen }
      close(f);
      Error := 0;
    end else
      Error := -7; { kein File empfangen }
  end;

  if DszLogFile <> '' then begin
    if not AnalyseDSZLog then begin
      if Prot <> pSend then
        RcvOk := FileRcvd; { im Zweifelsfall doch annehmen, das was ankam }
    end
  end else begin
    { Wenn kein DSZ.LOG erwnscht }
    case Prot of
      pSend   : SendOk := Error = 0;
      pReceive: RcvOk := Error = 0;
      pBiDir  : begin SendOk := Error = 0; RcvOk := SendOk; end;
    end;
  end;

  StopUhrZeit := GetSec100 - StopUhrStart;
  if StopUhrZeit < 0 then inc(StopUhrZeit, longint(24)*60*60*100);
  if Prot <> pReceive then
    if SendOk then begin
      SendCps := round((SendSize)/(StopUhrZeit/100));
      SendRecs := (SendSize + 64) div 128;
    end else begin
      SendCps := 0;
      SendRecs := 0;
    end;
  if Prot <> pSend then
    if RcvOk then begin
      RcvCps := round((RcvSize)/(StopUhrZeit/100));
      RcvRecs := (RcvSize + 64) div 128;
    end else begin
      RcvCps := 0;
      RcvRecs := 0;
    end;
  if Prot = pBiDir then
    if SendOk and RcvOk then begin
      SendCps := max(SendCps, RcvCps);
      RcvCps := SendCps;
    end;
  if Prot <> pReceive then
    writeln(Log, 'OUT:    ', SendSize/1024:6:1,' KB, ', SendCps:5,' cps -> ', OkTxt[SendOk]);
  if Prot <> pSend then
    writeln(Log, 'IN:     ', RcvSize/1024:6:1,' KB, ', RcvCps:5,' cps -> ', OkTxt[RcvOk]);
  if (Prot = pBiDir) and (SendOk and RcvOk) then begin
    AllSize := SendSize + RcvSize;
    AllRecs := (AllSize + 63) div 128;
    AllCps := round((AllSize) / (StopUhrZeit/100));
    writeln(log, 'OUT&IN: ', AllSize/1024:6:1,' KB, ', AllCps:5,' cps');
  end;

Leave:
  writeln(Log,'Error: ', Error);
end;

{===== NetBlock: gesicherte XModem-hnliche bertragung von Infoblcken ======}

function GetAck: boolean;
var
  s: string[2];
  loops: word;
begin
  ClearInput;
  GetAck := false;
  loops:=0;
  s:='??';
  if not WaitForChar(20) then exit;
  write(log,'GA1');
  repeat
    if not WaitForChar(20) then exit;
    write(log,'GA2');
    s[1]:=RawGetChr;
    if WaitForChar(10) then begin
      s[2]:=RawGetChr;
      write(log,'GA3');
    end else s[1]:=#0;
    inc(loops);
    if loops>10 then exit;
  until (s=NetAck) or (s=NetNak);
  GetAck:=(s=NetAck);
end;

procedure InitNetBlocks;
begin
  SndSeq:=1; RcvSeq:=1;
end;

function SendNetBlock(var Block: NetBlock): boolean;
var
  i,loops: word;
  Buf: array[0..sizeof(NetBlock)-1]of char absolute Block;
begin
  SendNetBlock := false;
  Block.Seq:=SndSeq; inc(SndSeq);
  case Block.Typ of
    tEnde:  Block.Len:=lEnde;
    tDatum: Block.Len:=lDatum;
    tProt:  Block.Len:=lProt;
    tAll:   Block.Len:=lAll;
  end;
  Block.CRC := CalcCRC(Block.Len, Block.Len-sizeof(word));
  loops:=0;
  repeat
    inc(loops);
    if (loops>3) or (not Carrier) then begin
      delay(5000); { Gegenseite soll ReceiveNetBlock verlassen }
      exit;
    end;
    if loops=1 then delay(1000)
      else delay(3000);
    writeln(log);
    write(log,'Send ');
    RawSendChr(NetBlockMarker);
    for i:=0 to Block.Len-1 do RawSendChr(Buf[i]);
  until GetAck;
  SendNetBlock := Carrier;
end;

function ReceiveNetBlock(var Block: NetBlock): boolean;
var
  loops: word;

  function doReceiveNetBlock: boolean;
  label
    Mist, Nichts;
  var
    i: word;
    Buf: array[0..sizeof(NetBlock)-1] of char absolute Block;
    error: boolean;
    loops: word;

    function GetChr: char;
    begin
      if WaitForChar(10) then GetChr:=RawGetChr
      else error:=true;
    end;

  begin
    doReceiveNetBlock := false;
    loops:=0;
    if not WaitForChar(40) then goto Nichts;
    repeat
      if not WaitForChar(20) then goto Mist;
      inc(loops); if loops>3 then goto Mist;
    until GetChr=NetBlockMarker;
    error:=false;
    { write(lende-1,' Chs: '); }
    for i:=0 to lEnde-1 do begin
      Buf[i]:=GetChr;
      { write('Ch',i); }
      if error then goto Mist;
    end;
    write('Len:',Block.Len);
    if Block.Len>sizeof(Block) then goto Mist;
    for i:=lEnde to Block.Len-1 do begin
      Buf[i]:=GetChr;
      { write('Ch',i); }
      if error then goto Mist;
    end;
    write('Block komplett ');
    if Block.CRC<>CalcCRC(Block.Len, Block.Len-sizeof(word)) then goto Mist;
    if (Block.Seq<>RcvSeq) and (Block.Seq<>pred(RcvSeq)) then goto Mist;
    RawSendStr(NetAck);
    if Block.Seq<>RcvSeq then exit;
    inc(RcvSeq);
    doReceiveNetBlock:=true;
    exit;
  Mist:
    delay(500);
    RawSendStr(NetNak);
    writeln(log);
    write(log,'Nak');
    ClearInput;
    exit;
  Nichts:
    writeln(log);
    write(log,'Nichts');
  end;

begin
  loops:=0;
  ReceiveNetBlock:=false; { initialisieren sollte man nicht vergessen ... }
  repeat
    inc(loops);
    if (loops>3) or (not Carrier) then exit;
  until doReceiveNetBlock;
  ReceiveNetBlock:=true;
end;

var
  f: file;
begin {|mnProto}
  {$I-}
  assign(f, 'dsz.out'); erase(f);
  {$I+}
  if Ioresult>0 then;
  GetConfigString(DszLogFile, 'DSZLOGFile', NetIOPath + 'DSZ.LOG');
end {|mnProto}.
