{ MNUTIL.PAS - Subroutinen fr mnMitt und mnAnruf }

unit mnUtil;

INTERFACE

uses
  crt,dos,m7utillo,m7config,
  m7dec,m7time,m7disk,m7utilg,m7msg,m7fileio,m7exec,
  mnDef,mnLog
  {$ifdef OS2} ,use32 {$endif};

type
  NetzMittParameter = record
    case boolean of true: (
      Status          : char;
      Id              : TNetId;
      Stichwort       : String[30];
      NetGrpW         : system.word;
      NetGrpB         : byte; { = Zielbox bei PMs }
      DatenOffset     : LongInt;
      Laenge          : system.word;
      MinusId         : TNetId;
      Distribution    : tDistribution);
    false: (
      dummy           : array[1..48] of byte;
    );
  end;
  NetzStatus = record
    case boolean of true: (
      Status          : char;
      Id              : TNetId;
      ZielBox         : Box;
      LStatus         : char;
      LDatum          : system.integer;
      LZeit           : system.integer; );
    false: (
      dummy           : array[1..16] of byte;
    );
  end;

  ExportFile = record { Export-Files: Dateien fr andere Boxen }
    DatFile: file; { wird mit RecordSize 1 erffnet }
    ParFile: file of NetzMittParameter;
    StaFile: file of NetzStatus;
    Open, StatOpen: boolean;
    Made, StatMade: boolean;
    Msgs: system.integer;
    FremdBox: boolean;
  end;

  BoxSet          = set of Box;

  MausNetMode = (NilMode,
                 Nachtnetz,              { nchtliche Anruf-Session }
                 MacheAnrufe,            { mache einen/mehrere Anruf(e) }
                 ErwarteAnrufe,          { erwarte einzelne(n) Anruf(e) }
                 NurImport,              { importiere entpackte Msg-Pakete }
                 NurExport,              { importiere entpackte Msg-Pakete }
                 VerbindungUebernehmen); { uebernehme CONNECT von Maus }
  NachtnetzMode = (Nacht, Nacht1, Nacht2);

  ProfilerStr = string[10];

const
  MaxExportsOpen: byte = 2;
  { wie viele Files drfen gleichzeitig auf sein ? }
var
  ExportFiles: array[1..DefDirectBoxMax] of ExportFile;
  ExportsOpen: byte; { Anzahl der offenen Exportfiles }
var
  GotFileName: PathStr; { wird von mnAnruf gesetzt }
var
  CallOrder       : array[1..DefBoxenMax] of Box;
  DontWaitFor     : BoxSet;
  DontCall        : BoxSet;
  NoExpTo         : BoxSet;
  MinBaud         : array[1..DefDirectBoxMax] of word;
  BoxProto        : array[1..DefDirectBoxMax] of char;
  ProtoBiDir      : string[10];
var
  NetMode         : MausNetMode;
  NachtModus      : NachtnetzMode;
  NotFremd        : array[0..DefDirectBoxMax] of boolean;
  ThisAndFremd,
  AnUnsDran       : set of Box;
  ServerBox       : Box;
  FromBox         : Box; { wessen Msgs werden gerade verteilt? }
  PackZeitProMB   : word;
  OldVersion      : string[10];
  VersStr         : string[2]; { 1.10 -> [2]:#01#$10 }
  tim, timLast    : TimingTyp;
  Password        : array[1..DefDirectBoxMax] of string[8];

(*
function FindZielBox(s: string; var GateWayDist: integer; var direct: boolean): Box;
*)
function GenName(Von, Nach: Box): string;

function GetViaBox(b: Box): Box;

function GetNetGrp(var NetPar: NetzMittParameter): word;

function MsgId(Id: TNetId): string;

function BoxList(var bs: BoxSet): string;


procedure InitExportFiles;

procedure OpenExportFile(db: DirectBox);

procedure CloseExportFile(db: DirectBox);

procedure CloseExportFiles;

procedure DeleteExportFiles(db: DirectBox; PackFile: string);

function PackeExportFiles(db: DirectBox; Packer: char;
  var FileName: FileStr; var PackZeit: word): boolean;

{$ifdef MausNet}
procedure InitMsgFiles;
{$endif}

procedure UtilInit;

procedure OpenStatusFile(db: DirectBox);

procedure CloseStatusFile(db: DirectBox);

function FindBoxNum(s: string): Box;

procedure GetBoxConfigs;

procedure MoreFiles;

function FreeHandles: byte;

procedure CheckHandles;

function GetFileTime(var f; WennIllegalDann: word): LongInt;

procedure ProfilerInit;

procedure ProfilerStart(txt: ProfilerStr);

procedure ProfilerEnde(txt: ProfilerStr);

procedure ProfilerStatistik;


procedure MsgStat(Status: char; Von, An: Box; Laenge: word);

procedure GrpStat(NetGrp: Netzgruppe; Laenge: word);

procedure TimingInit;

procedure TimingAdd(var tim: TimingTyp; FPos: word);

procedure TimingExit;


IMPLEMENTATION

{========================== allgemeine Subroutinen ===========================}

var
  MsgStatTage, TimStatTage: word;

function GetViaBox(b: Box): Box;
begin
  if b=0 then GetViaBox := 0
  else GetViaBox := Boxen^[b].ViaBox;
  { CheckGst; }
end;

function GetNetGrp(var NetPar: NetzMittParameter): word;
begin
  with NetPar do begin
    if NetGrpB = 0 then begin
      if NetGrpW > 0 then begin
        {--- Bugfix fr die 1.93-File-bertragung}
        write(log, ' <NetGrpFix:' + IntToStr(NetGrpW) + '> ');
        NetGrpB := NetGrpW;
        NetGrpW := 0;
      end;
    end;
    if NetGrpB = 255 then
      GetNetGrp := NetGrpW
    else
      GetNetGrp := NetGrpB;
  end;
  { CheckGst; }
end;

{------------------ ExportFiles fr alle "abhngigen" Boxen ------------------}

function GenName(Von, Nach: Box): string;
{ Datei von AC nach MS:
  frher: MNAC-MS-.*; allgemein: MNvvvnnn; vvv, nnn aufgefllt mit -
  jetzt : AC--MS--.*; wenn Krzel nicht pat, Nummer mit 0 aufgefllt
     also AC--0123.* wenn Box 123 CH-XY ist }

  function IOName(b: Box): string;
  var
    s: string[8];
  begin
    s := Boxen^[b].Kuerzel;
    if length(s) <= 4 then
      IOName := CopyL(s + '---', 4)
    else begin
      s := '000' + IntToStr(b);
      IOName := Copy(s, length(s)-3, 4);
    end;
  end;

begin
  GenName := NetIOPath + IOName(Von) + IOName(Nach)
end;

procedure InitExportFiles;
  {-- generiert nur die Namen. Files werden in OpenExport angelegt }
var
  b: Box;
  db: DirectBox;
  IOerror: integer;
  OldName, NewName,
  FileName: PathStr;

  procedure Ren(ext: ExtStr);
  begin
    if DateiDa(OldName + Ext) then begin
      writeln(log, 'MOVE ', OldName + Ext, ' ', NewName + Ext);
      if not MoveFile(OldName + Ext, NewName + Ext) then
        SysopLog('MOVE '+ OldName + Ext + ' ' + NewName + Ext + ': Fehler!');
    end;
  end;

begin { InitExportFiles }
  FillChar(ExportFiles,sizeof(ExportFiles),0);
  for db:=1 to MaxDirectBox do begin
    b := DirectToBox[db];
    with ExportFiles[db] do begin
      FileName:=GenName(ThisBox,b);
      assign(ParFile, FileName+'.par');
      assign(DatFile, FileName+'.dat');
      assign(StaFile, FileName+'.sta');
      (* fillchar entspricht:
      open := false;
      StatOpen := false;
      Made := false;
      StatMade := false;
      Msgs := 0;
      *)
      FremdBox := Boxen^[b].FremdBox;
    end;
  end;
  ExportsOpen := 0;
end;

procedure CloseExportFile(db: DirectBox);
begin
  with ExportFiles[db] do begin
    if open then begin
      close(DatFile);
      close(ParFile);
      open:=false;
      dec(ExportsOpen);
    end;
  end;
end;

procedure OpenStatusFile(db: DirectBox);
var
  IOerror: integer;
begin
  with ExportFiles[db] do begin
    if FremdBox then writeln(log, 'Open Status ',db, #7);
    if not StatMade then begin
      {$I-} reset(StaFile); {$I+}
      IOerror := IOresult;
      if IOerror = 0 then { Datei offen, ok } else
      if IOerror = 2 then { Datei nicht da } rewrite(StaFile) else
        reset(StaFile);   { Fatal-Error produzieren }
      StatMade := true;
      StatOpen := true;
    end;
    if not StatOpen then begin
      reset(StaFile);
      StatOpen:=true;
    end;
    CheckHandles;
  end;
end;

procedure CloseStatusFile(db: DirectBox);
begin
  with ExportFiles[db] do begin
    if StatOpen then begin
      close(StaFile);
      StatOpen:=false;
    end;
  end;
end;

procedure OpenExportFile(db: DirectBox);
var
  c: Box;
  IOerror: integer;
label
  MustCloseFirst;

  procedure CloseFirst;
  var
    db,MinBox: DirectBox;
    MinWert: integer;
  begin
    MinWert:=MaxInt;
    for db:=1 to MaxDirectBox do begin
      {--- suche die Box, die bisher am wenigstens bekommen hat }
      with ExportFiles[db] do begin
        if open and (Msgs<MinWert) then begin
          MinBox := db; MinWert := Msgs;
        end;
      end;
    end;
    CloseExportFile(MinBox);
  end;

begin {OpenExportFile}
  with ExportFiles[db] do begin

    if FremdBox then writeln(log, 'Open Export ',db, #7);

    if not open then begin
      if ExportsOpen >= MaxExportsOpen then
        { wahrscheinlich keine Handles mehr frei: erst andere Files zumachen }
        CloseFirst;
    end;

    if not made then begin
      {--- erst prfen, ob Files vorhanden, sonst anlegen }
      {$I-} reset(DatFile,1); {$I+}
      IOerror := IOresult;
      if IOerror = 0 then { Datei offen, ok } else
      if IOerror = 2 then { Datei nicht da } rewrite(DatFile,1) else
        reset(DatFile);   { Fatal-Error produzieren }

      {$I-} reset(ParFile); {$I+}
      IOerror := IOresult;
      if IOerror = 0 then { Datei offen, ok } else
      if IOerror = 2 then { Datei nicht da } rewrite(ParFile) else
        reset(ParFile);   { Fatal-Error produzieren }
      made := true;
      open := true;
      inc(ExportsOpen);
    end;

    if not open then begin
      {--- open mit IOcheck; wenn keine Handles mehr frei, andere zumachen }
      {$I-} reset(DatFile,1); {$I+}
      IOerror := IOresult;
      if IOerror = 0 then { Datei offen, ok } else
      if IOerror = 4 then { too many open files }
        goto MustCloseFirst
      else
        reset(DatFile);   { Fatal-Error produzieren }

      {$I-} reset(ParFile); {$I+}
      IOerror := IOresult;
      if IOerror = 0 then { Datei offen, ok } else
      if IOerror = 4 then begin
        {--- too many open files: erst andere Exportfiles zumachen }
        close(DatFile); { war ja schon auf ... }
        MustCloseFirst:
          if MaxExportsOpen>1 then dec(MaxExportsOpen);
            { hmm.. soviele drfen doch nicht auf sein }
          writeln(log, 'MaxExportsOpen reduziert auf ',MaxExportsOpen,bell);
          CloseFirst;
        Reset(DatFile,1);
        Reset(ParFile);
      end else
        reset(ParFile);   { Fatal-Error produzieren }

      open:=true;
      inc(ExportsOpen);
    end;
    CheckHandles;
  end;
end;

procedure CloseExportFiles;
  {--- schliet alle ExportFiles }
var
  db: DirectBox;
begin
  for db:=1 to MaxDirectBox do begin
    CloseExportFile(db);
    CloseStatusFile(db);
  end;
end;

procedure DeleteExportFiles(db: DirectBox; PackFile: string);
{ nach erfolgreicher bertragung werden die Export-Dateien gelscht }
var
  SR: SearchRec;
  D: DirStr;
  N: NameStr;
  E: ExtStr;
  f: file;
begin
  with ExportFiles[db] do begin
    {$I-}
    erase(DatFile); if IOresult>0 then writeln(log, 'Erase DAT Error');
    erase(ParFile); if IOresult>0 then writeln(log, 'Erase PAR Error');
    erase(StaFile); if IOresult>0 then;
    {$I+}
    Made := false; StatMade := false;
    { lsche andere Files mit gleichem Namen (.ZOP, .M2M) }
    FSplit(PackFile, D, N, E);
    FindFirst(NetIoPath + N + '.*', AnyFile-Directory, SR);
    while DosError = 0 do begin
      if SR.Name <> N + E then begin
        assign(f, NetIoPath + SR.Name);
        {$I-}
        erase(f);
        {$I+}
        writeln(log, 'Erase ', SR.Name, ': ', IOresult);
      end;
      FindNext(SR);
    end;
  end;
end;

{$ifdef MausNet}
procedure InitMsgFiles;
begin
  InitMsgIdx; { Mitteilungs-Index aufbauen }
  InitUserIdx;
  writeln(Log);
end;
{$endif}

{-------------------------- Packen der Export-Files --------------------------}

function PackeExportFiles(db: DirectBox; Packer: char;
  var FileName: FileStr; var PackZeit: word): boolean;
  {--- Aufruf mit Packzeit > 0 -> nicht packen, sondern Zeitabschtzung }
var
  Name: string[64];
  Leer: boolean;
  f: file of byte;
  PackTyp: string[3];
  b: Box;
  PackTime, ParTime, StaTime, PackSize: LongInt;
  DatSize: LongInt;
  Start, Zeit: LongInt;

  function PackExists(Typ: string5): boolean;
  var
    IsDa: boolean;
  begin
    {$I-}
    assign(f, name + '.' + Typ); reset(f);
    {$I+}
    IsDa := (IOresult=0);
    PackExists := IsDa;
    if IsDa then close(f);
  end;

begin { PackeExportFiles }
  b:=DirectToBox[db];
  Name:=GenName(ThisBox,b);
  if Packer='Z' then PackTyp:='ZIP' else PackTyp:='ARC';

  OpenExportFile(db);
  DatSize := FileSize(ExportFiles[db].DatFile);
  Leer := (DatSize = 0);
  PackeExportFiles := not Leer;
  { if PackZeit = 0 then !!! }
    {--- fr Zeitabschtzung }
    ParTime := GetFileTime(ExportFiles[db].ParFile, today);
  CloseExportFile(db);

  {--- vielleicht schon der aktuelle ARC/ZIP vorhanden ? }
  FileName := Name+'.'+PackTyp;
  if PackExists(PackTyp) then begin
    reset(f);
    PackTime := GetFileTime(f, 0);
    PackSize := FileSize(f);
    close(f);
    if PackSize = 0 then begin
      SysopLog(FileName + ': 0 Bytes - wird neu gepackt');
    end else
    if PackTime >= ParTime then begin
      OpenStatusFile(db);
      StaTime := GetFileTime(ExportFiles[db].StaFile, today);
      CloseStatusFile(db);
      if PackTime >= StaTime then begin
        {--- Pack aktueller als .PAR und .STA -> fertig }
        writeln(log, PackTyp,' fr ',BoxName(b),' bereits aktuell.');
        PackZeit := 0; { kein Zeitbedarf mehr }
        exit;
      end;
    end;
  end;
  if PackZeit > 0 then
    {--- Zeitabschtzung gewnscht }
    Packzeit := trunc((DatSize * PackZeitProMB) / 1000000) + 1
  else begin
    {--- vorher ARC/ZIP lschen }
    if PackExists('ARC') then erase(f);
    if PackExists('ZIP') then erase(f);

    writeln(log, PackTyp,' fr ',BoxName(b),' wird angelegt.');
    Start := BIOSticker;
    cdd(NetIOPath);
    Exec('PKZIP -a ' + FileName + ' ' + Name + '.*', true, false);
    cdd(MausNetPath);
    Zeit := TickerDiff(Start);
    if Zeit <= 0 then Zeit := 1;
    if DatSize > 100000 then begin
      Zeit := round(Zeit / 18.2 / DatSize * 1000000);
      writeln(log, 'PackZeitProMB := ', Zeit);
    end;
    if not PackExists(PackTyp) then begin
      SysopLog(PackTyp + ' tut''s nicht !'#7#7#7);
      Leer := true; { keine Export-Files verschicken ... }
    end;
    PackeExportFiles := not Leer;
  end;
    { return true, wenn Datei nicht leer }
end;

function FindBoxNum(s: string): Box;
var
  b: box;
begin
  b:=0;
  repeat
    inc(b);
    if BoxName(b)=s then begin
      FindBoxNum := b;
      exit;
    end;
  until b>=MaxBoxen;
  FindBoxNum := 0;
  { CheckGst; }
end;

var
  BoxFromStr: string[80];
  BoxFromPtr: byte;

procedure SetBoxFromStr(s: string);
begin
  BoxFromStr := s;
  BoxFromPtr := 0;
end;

function GetBoxFromStr: Box;
var
  p,q: byte;
  b: box;
begin
  if BoxFromPtr>=length(BoxFromStr) then begin
    GetBoxFromStr := 0;
    exit;
  end;
  p:=BoxFromPtr;    { 'M, HB,BN2' }
  repeat            { 0123456790  }
    q:=p;           {   q   p     }
    repeat
      inc(p);
    until (p>length(BoxFromStr)) or (BoxFromStr[p]=',');
    b := FindBoxNum( AllTrim(copy(BoxFromStr,q+1,p-q-1)) );
  until (b>0) or (p>length(BoxFromStr));
  BoxFromPtr := p;
  GetBoxFromStr := b;
end;

function BoxList(var bs: BoxSet): string;
var
  first: boolean;
  b: Box;
  s: string;
begin
  first := true;
  s := '';
  for B := 1 to MaxBoxen do begin
    if B in bs then begin
      if first then first := false
        else s := s + ', ';
      s := s + BoxName(B);
    end;
  end;
  BoxList := s;
end;

procedure GetBoxSet(var bs: BoxSet; {const} s: string);
var
  b: Box;
  z: string;
begin
  GetConfigString(z, s, '');
  SetBoxFromStr(z);
  bs:=[];
  repeat
    b:=GetBoxFromStr;
    if b>0 then bs := bs+[b];
  until b=0;
  if bs<>[] then begin
    write(s,' := ''',BoxList(bs));
    writeln('''');
  end;
end;

procedure GetBoxConfigs;
var
  o: box;

  procedure TrageEvtlEin(b: box);
  var
    p: Box;
  begin
    with Boxen^[b] do
    if (UnterMir or UeberMir) and (not FremdBox) then begin
      for p:=1 to o do
        if CallOrder[p]=b then exit;
      inc(o);
      CallOrder[o] := b;
    end;
  end;

var
  b: box;
  db: DirectBox;
  ToBox: string[KuerzelLen];
  Pw, z: string;
begin
  for db:=0 to MaxDirectBox do begin
    b := DirectToBox[db];
    NotFremd[db] := not ((Boxen^[b].UnterMir) and (Boxen^[b].FremdBox));
  end;
  GetConfigString(z, 'CallOrder', '');
  SetBoxFromStr(z);
  o := 0;
  FillChar(CallOrder, sizeof(CallOrder), 0);
  repeat
    b := GetBoxFromStr;
    if b>0 then
      TrageEvtlEin(b);
  until b=0;
  for b:=1 to MaxBoxen do
    TrageEvtlEin(b);
  write('CallOrder := ''');
  for b:=1 to MaxBoxen do
    if CallOrder[b]>0 then begin
      if b > 1 then write(', ');
      write(BoxName(CallOrder[b]));
    end;
  writeln('''');
  GetBoxSet(DontWaitFor, 'DontWaitFor');
  GetBoxSet(DontCall, 'DontCall');
  for db:=1 to MaxDirectBox do begin
    b := DirectToBox[db];
    BoxProto[db] := GetConfigChar('Protokoll.' + BoxName(b), 'Z');
  end;
  GetConfigString(ProtoBiDir, 'Protokoll.Bidirect', 'H');
  GetBoxSet(NoExpTo, 'NoExpTo');
  {--- Beispiel: 'MinBaudWAF' := 1200 }
  FillChar(MinBaud, sizeof(MinBaud), 0);
  FillChar(Password, sizeof(Password), 0);
  for db:=1 to MaxDirectBox do begin
    b := DirectToBox[db];
    GetConfigString(Pw, 'Password' + BoxName(b), '');
    if Pw <> '' then
      Password[db] := CopyL(Pw + '       ', 8);
    MinBaud[db] := GetConfigWord('MinBaud' + BoxName(b), 0);
    if ConfigOk then
      writeln('MinBaud', BoxName(b), ' := ', MinBaud[db]);
  end;
  ThisAndFremd := [];
  AnUnsDran := [];
  ServerBox := 0;
  for b:=1 to MaxBoxen do begin
    if (b=ThisBox) or (Boxen^[b].FremdBox and Boxen^[b].UnterMir) then
      ThisAndFremd := ThisAndFremd + [b];
    if not Boxen^[B].FremdBox then begin
      if Boxen^[B].uebermir then
        ServerBox := B;
      if Boxen^[B].uebermir or Boxen^[B].untermir then
        AnUnsDran := AnUnsDran + [B];
    end;
  end;
  AtHere := ' @ ' + Boxen^[ThisBox].Kuerzel;
end;

function MsgId(Id: TNetId): string;
var
  s: string[5];
begin
  if Id.Box=0 then
    MsgId := '         '
  else begin
    str(Id.Nummer:5, s);
    MsgId := s+'@'+AlignL(BoxName(Id.Box), KuerzelLen);
  end;
  { CheckGst; }
end;

{--------------------- Version mit direct patch des PSP ----------------------}
const
  DefHandleMax = 50;
var
  HandleTab: array[1..DefHandleMax] of byte;
  MaxFiles: word;
const
  HandleTabUsed: boolean = false;

procedure MoreFiles;
type
  PSP = record
    case boolean of true: (
      d1:     array[0..$17] of byte;
      Tab:    array[1..20] of byte;    { Tabelle der Handles }
      d2:     array[$2C..$31] of byte;
      len:    word;                    { Lnge der Tabelle }
      TabPtr: pointer; );              { Adresse der Tabelle }
    false: (
      b:      array[0..$FF] of byte; );
  end;
  SegOfs = record
      ofs, seg: word;
    end;
var
  PSPptr: ^PSP;
  c: byte;
  Regs: Registers;
  ok: boolean;
begin
{$ifndef OS2}
  MaxFiles := GetConfigWord('MaxFiles', 0);
  if ConfigOk and (MaxFiles > 20) then begin
    MaxFiles := min(MaxFiles, DefHandleMax);

    Regs.AH := $67;
    Regs.BX := MaxFiles;
    msdos(Regs);
    ok := not odd(Regs.Flags);
    if not ok then begin
      writeln(log, 'MaxFiles klappt nicht (AX=', hex(regs.AX,4), ').');
      {$ifndef dpmi}
        PSPptr := ptr(PrefixSeg,0);
        with PSPptr^ do begin
          if (len>20) or (addr(TabPtr^) <> addr(Tab)) then
            SysopLog('PSP nicht in Ordnung.'#7)
          else begin
            move(PSPptr^.tab,HandleTab,len);
            for c:=len+1 to MaxFiles do HandleTab[c]:=$FF;
            len := MaxFiles;
            TabPtr := addr(HandleTab);
            HandleTabUsed := true;
            ok := true;
          end;
        end;
      {$endif}
    end;
    if ok then begin
      MaxExportsOpen := (MaxFiles - 20) div 2 + 2;
      writeln(scr, 'Max. ExportFiles Open: ', MaxExportsOpen);
    end;
  end;
{$endif} (* OS2 *)
end;


function FreeHandles: byte;
var
  free,c: word;
begin
  if HandleTabUsed then begin
    free := 0;
    for c:=1 to MaxFiles do
      if HandleTab[c]=$FF then inc(free);
    FreeHandles := free;
  end else
    FreeHandles := 20; { hmm.. }
end;

const
  MinHandleFree : word = 3;

procedure CheckHandles;
var
  free: word;
begin
  if HandleTabUsed then begin
    free := FreeHandles;
    if free<MinHandleFree then begin
      write(log,'<MinHandleFree: ', free,'>');
      MinHandleFree := free;
    end;
  end;
end;

function GetFileTime(var f; WennIllegalDann: word): LongInt;
var
  ft, ftjetzt: LongInt;
  dt: DateTime;
  t, m, j: byte;
  time: LongInt;
  s: string;
  i: integer;
begin
  GetFTime(f, ft);
  with dt do begin
    IntTotmj(GetDateInt, t, m, j);
    year := j + 1900;
    month := m;
    day := t;
    time := GetSecondInt + 60; { 60 Sekunden drauf geben fr
      Datumsschwankungen in lokalen Netzwerken }
    sec := time mod 60;
    time := time div 60;
    min := time mod 60;
    Hour := time div 60;
  end;
  PackTime(dt, ftjetzt);
  {$ifdef Debug}
    i := 0;
    repeat inc(i) until (FileRec(f).Name[i] = #0) or (i=79);
    move(FileRec(f).Name, s[1], i);
    s[0] := chr(i);
    with dt do
    writeln(Log, '<', s + ': ', ft, ' = ', FileDateToMaus(ft), ' ', FileTimeToMaus(ft),
            ' jetzt: ', ftjetzt, ' = ', FileDateToMaus(ftjetzt), ' ', FileTimeToMaus(ftjetzt), '>');
  {$endif}
  if ftjetzt < ft then begin
    i := 0;
    repeat inc(i) until (FileRec(f).Name[i] = #0) or (i=79);
    move(FileRec(f).Name, s[1], i);
    s[0] := chr(i);
    SysopLog(s + ': Datum in der Zukunft.');
    if WennIllegalDann = 0 then
      ft := 0
    else
      ft := ftjetzt;
  end;
  GetFileTime := ft;
end;

{============================= Profiler-Routinen =============================}

{$R-,S-}

const
  ProfilerMax = 50;
  ProfilerEbenen = 10;
type
  ProfilerRec = record
    name: ProfilerStr;
    unter: byte;
    runs: boolean;
    calls: word;
    start: LongInt;
    time: LongInt;
  end;
var
  pf: array[1..ProfilerMax] of ProfilerRec;
  pfMax,pfAct: integer;

procedure ProfilerInit;
begin
  pfMax := 0; pfAct := 0;
  FillChar(pf, sizeof(pf), 0);
end;

procedure ProfilerStart(txt: ProfilerStr);
var
  p, p2, last: integer;
  found: boolean;
begin
  p := pfAct; { entweder unter dem aktuellen schon vorhanden oder neu .. }
  found := false;
  repeat
    inc(p);
    if p<=pfMax then
      found := (pf[p].unter=pfAct) and (pf[p].name=txt);
  until (p>pfMax) or found;
  if p > pfMax then begin
    if pfMax = ProfilerMax then begin
      SysopLog('ProfilerMax berschritten.'); exit;
    end else begin
      pfMax := p;
      with pf[p] do begin
        name := txt; { Rest ist durch FillChar auf 0 }
        unter := pfAct;
      end;
    end;
  end;
  pfAct := p;
  with pf[p] do begin
    if runs then SysopLog('Profile '+name+' luft schon.');
    runs := true;
    start := BIOSticker;
    inc(calls);
  end;
  { CheckGst; }
end;

procedure ProfilerEnde(txt: ProfilerStr);
var
  p: integer;
begin
  if pf[pfAct].name=txt then begin
    with pf[pfAct] do begin
      runs := false;
      inc(time, BIOSticker-start);
      pfAct := unter;
    end;
  end else begin
    {--- hmm... suchen }
    SysopLog('ProfilerEnde von '+txt+' statt '+pf[pfAct].Name);
    for p:=1 to pfMax do
      if pf[p].name=txt then begin
        with pf[p] do begin
          runs := false;
          inc(time, BIOSticker-start);
        end;
      end;
  end;
  { CheckGst; }
end;

procedure ProfilerStatistik;
var
  p,p2,ebene: integer;
begin
  writeln(log);
  writeln(log);
  writeln(log,'Profile');
  writeln(log);
  writeln(log,'Name      ','':ProfilerEbenen*2,'Aufrufe   Zeit[s]');
  for p:=1 to 27 + ProfilerEbenen*2 do write(log,'-');
  writeln(log);
  for p:=1 to pfMax do begin
    ebene := 0; p2 := pf[p].unter;
    while p2<>0 do begin
      inc(ebene); p2 := pf[p2].unter;
    end;
    with pf[p] do begin
      write(log, '': ebene*2, AlignL(Name, 10+(ProfilerEbenen-ebene)*2), calls:7, time/18.2:10:1);
      if runs then write(log,' luft!');
      writeln(log);
    end;
  end;
  for p:=1 to 27 + ProfilerEbenen*2 do write(log,'-');
  writeln(log);
end;

{==== Msg-Statistik ====}

{$R+,S+}
var
  mst: ^MsgStatTyp;
  mstLeer: boolean;

procedure MsgStatInit;
var
  db: DirectBox;
begin
  new(mst);
  FillChar(mst^, sizeof(mst^), 0);
  mst^.Datum := GetDateInt;
  mst^.BoxMax := MaxDirectBox;
  for db:=0 to MaxDirectBox do
    mst^.boxen[db] := IntToStr(DirectToBox[db]);
  mstLeer := true;
end;

procedure MsgStat(Status: char; Von, An: Box; Laenge: word);

  function GetDirect(b: box): DirectBox;
  var
    via: Box;
  begin
    GetDirect := 0;
    if b=ThisBox then exit;
    via := GetViaBox(b);
    if via=0 then exit;
    GetDirect := Boxen^[via].Direct;
  end;

var
  DirectVon, DirectAn: DirectBox;
begin
  if Status = 'F' then exit;
  DirectVon := GetDirect(Von);
  DirectAn := GetDirect(An);
  with mst^.msgs[(Status='P'), DirectVon, DirectAn] do begin
    inc(Anzahl); inc(Bytes, Laenge);
  end;
  mstLeer := false;
end;

procedure MsgStatistik;

  procedure HorzLine(n: byte);
  var
    an: DirectBox;
  begin
    write(log, '-------+');
    for an:=1 to n do write(log, '-------');
    writeln(log, '-+-------');
  end;

var
  tab,art: boolean;
  von, an: DirectBox;
  sum,SumVon: longint;
  SumBox: array[DirectBox] of LongInt;
  val: LongInt;
  f, f2: file;
  len, n: word;
  AbDatum: integer;
label
  MnMsgPutt;
begin
  if mstLeer then exit;
  writeln(log);
  writeln(log, 'Mitteilungs-Aufkommen:');
  writeln(log);
  for art:=false to true do begin
    for tab:=false to true do begin
      if art then write(log,'Persnliche')
        else write(log, 'Allgemeine');
      if tab then writeln(log,' Mitteilungen [Bytes]')
        else writeln(log,' Mitteilungen [Anzahl]');
      writeln(log);
      writeln(log,'   \ an|');
      write  (log,'von  \ |');
      with mst^ do begin
        n := 0;
        for an:=0 to BoxMax do
          if NotFremd[an] then begin
            write(log, AlignR(BoxName(DirectToBox[an]), 7)); inc(n);
          end;
        writeln(log,' |');
        HorzLine(n);
        FillChar(SumBox, sizeof(SumBox), 0);
        SumVon := 0;
        for von:=0 to BoxMax do begin
          if NotFremd[von] then begin
            sum := 0;
            write(log, AlignL(BoxName(DirectToBox[von]), 7), '|');
            for an:=0 to BoxMax do begin
              if NotFremd[an] then begin
                with msgs[art, von, an] do begin
                  if tab then val := bytes else val := anzahl;
                  if an <> von then
                    inc(SumBox[an], val)
                  else begin
                    sum := val; val := 0;
                  end;
                  write(log, val:7);
                end;
              end;
            end;
            writeln(log,' |', sum:7);
            inc(SumVon, sum);
          end;
        end;
        HorzLine(n);
        write(log,'|':8);
        for an:=0 to BoxMax do
          if NotFremd[an] then
            write(log, SumBox[an]:7);
        writeln(log,' |',SumVon:7);
        writeln(log);
      end;
    end;
  end;

  {--- File-Update }
  assign(f, MsgStatFile);
  {$I-} reset(f, 1); {$I+}
  if IOresult=0 then seek(f, FileSize(f))
  else rewrite(f, 1);
  len := sizeof(mst^);
  blockwrite(f, len, 2);
  blockwrite(f, mst^, len);
  close(f);

  {--- Filegre trimmen }
  reset(f, 1);
  BlockRead(f, len, 2);
  if len > sizeof(mst^) then
    goto MnMsgPutt;
  BlockRead(f, mst^, len);
  AbDatum := GetDateInt - MsgStatTage; { ein Monat plus Sicherheitsreserve }
  if mst^.Datum < AbDatum-1 then begin
    writeln(log, 'MN-MSG.DAT wird verkleinert.');
    assign(f2, 'MN-MSG.$$$');
    rewrite(f2, 1);
    repeat
      BlockRead(f, len, 2);
      if len > sizeof(mst^) then
        goto MnMsgPutt;
      BlockRead(f, mst^, len);
      if mst^.Datum > AbDatum then begin
        BlockWrite(f2, len, 2);
        BlockWrite(f2, mst^, len);
      end;
    until eof(f);
    close(f);
    close(f2);
    erase(f);
    rename(f2, MsgStatFile);
  end else
    close(f);
  exit;
  MnMsgPutt:
  SysopLog('MN-MSG.DAT defekt - bitte lschen');
end;

{============================== Gruppen-Statistik ==========================}

var
  gst: ^GrpStatTyp;
const
  OrgDate: integer = 0;

procedure GrpStatInit;
begin
  new(gst);
  FillChar(gst^, sizeof(gst^), 0);
  gst^.Datum := GetDateInt;
  OrgDate := gst^.Datum;
end;

(*
procedure CheckGst;
type
  ByteArr = array[0..9999] of byte;
var
  c: word;
  pByte: ^ByteArr;
begin
  if (OrgDate <> 0) and (gst^.Datum <> OrgDate) then begin
    writeln(log);
    writeln(log, 'gst^');
    pByte := @gst^;
    for c := 0 to sizeof(gst^)-1 do begin
      write(log, Hex(pByte^[c], 2), ' ');
      if c mod 16 = 15 then
        writeln(log);
    end;
    writeln(log);
    RunError(199);
  end;
end;
*)

procedure GrpStat(NetGrp: Netzgruppe; Laenge: word);
begin
  with gst^.grps[NetGrp] do begin
    inc(Anzahl); inc(Bytes, Laenge);
  end;
  { CheckGst; }
end;

procedure GrpStatExit;
var
  f: file of GrpStatTyp;
  gst2: ^GrpStatTyp;
  g: Netzgruppe;
begin
  {--- File-Update }
  assign(f, GrpStatFile);
  { write(log, '<GrpStat: Reset>'); }
  {$I-} reset(f); {$I+}
  if IOresult = 0 then begin
    {--- File vorhanden: wenn da, letzten Record einlesen und vergleichen }
    if not eof(f) then begin
      { write(log, '<GrpStat: Seek1(', FileSize(f)-1, ')>'); }
      seek(f, FileSize(f) -1);
      new(gst2);
      read(f, gst2^);
      if gst2^.Datum = gst^.Datum then begin
        for g := 0 to DefGrpMax do begin
          with gst^.Grps[g] do begin
            inc(anzahl, gst2^.Grps[g].Anzahl);
            inc(bytes, gst2^.Grps[g].Bytes);
          end;
        end;
        { write(log, '<GrpStat: Seek2(', FileSize(f)-1, ')>'); }
        seek(f, FileSize(f) -1);
      end;
    end;
  end else begin
    { write(log, '<GrpStat: Rewrite>'); }
    rewrite(f);
  end;
  { write(log, '<GrpStat: Write>'); }
  write(f, gst^);
  close(f);
end;

{============================== Timing-Statistik ==========================}

var
  timFPos: word;  { Position des /1-Records }

procedure TimingInit;
var
  f: file of TimingTyp;
  fp: word;
begin
  FillChar(tim, sizeof(tim), 0);
  tim.IchBin := ThisBox;
  tim.UeberMir := ServerBox;
  tim.Datum := GetDateInt;
  tim.Version := VersStr;
  timFPos := 0;
  timLast.IchBin := 0;
  assign(f, TimingFile);
  {$I-} reset(f); {$I+}
  if IOresult = 0 then begin
    fp := FileSize(f);
    if fp > 0 then begin
      repeat
        dec(fp);
        seek(f, fp);
        read(f, timLast);
        if (timLast.IchBin = ThisBox) and (timLast.Datum = GetDateInt) then begin
          {--- Timing-Infos von einem /1-Aufruf schon da }
          tim := timLast;
          timLast.IchBin := 0;
          timFPos := fp;
        end;
      until (timLast.IchBin = ThisBox) or (fp = 0);
    end;
  end else
    rewrite(f);
  close(f);
end;

procedure TimingAdd(var tim: TimingTyp; FPos: word);
var
  f: file of TimingTyp;
begin
  assign(f, TimingFile);
  {$I-} reset(f); {$I+}
  if IOresult > 0 then
    rewrite(f)
  else begin
    if FPos = 0 then
      seek(f, filesize(f))
    else
      seek(f, FPos);
  end;
  write(f, tim);
  close(f);
end;

procedure TimingExit;
var
  f, f2: file of TimingTyp;
  TimN: TimingTyp;
  AbDatum: integer;
begin
  TimingAdd(Tim, timFPos);

  {--- Filegre trimmen }
  assign(f, TimingFile);
  {$I-} reset(f); {$I+}
  if IOresult > 0 then exit;
  Read(f, TimN);
  AbDatum := GetDateInt - TimStatTage; { ein Monat plus Sicherheitsreserve }
  if (TimN.Datum < AbDatum-2) then begin
    writeln(log, TimingFile, ' wird verkleinert.');
    write('      / ', FileSize(f), ' Recs'#13);
    assign(f2, 'MN-TIM.$$$');
    rewrite(f2);
    repeat
      if FilePos(f) mod 16 = 0 then
        write(FilePos(f):5, #13);
      Read(f, TimN);
      if TimN.Datum > AbDatum then begin
        Write(f2, TimN);
      end;
    until eof(f);
    writeln(log, FileSize(f), ' Recs -> ', FileSize(f2), ' Recs.');
    close(f);
    close(f2);
    erase(f);
    rename(f2, TimingFile);
  end else
    close(f);
end;

{=========================== Init/Exit-Prozeduren =========================}

var
  ExitSave: pointer;

{$F+} procedure ExitUtil; {$F-}
begin
  ExitProc := ExitSave;
  CloseExportFiles;
  if ExitCode in [0, 80..89, 255] then begin
    {--- kein Fehler oder Ctrl-Break }
    WithTime := false; { LogFile-Uhrzeit aus }
    ProfilerStatistik;
    MsgStatistik;
    GrpStatExit;
    SysopProt('');
    if ExitCode = 255 then SysopProt('MausNet durch Ctrl-Break beendet')
      else if ExitCode = 0 then SysopProt('MausNet beendet')
        else SysopProt('MausNet durch Modemfehler beendet');
    SysopProtExit('MausNet', 'MausNet-Report');;
  end;
end;

procedure UtilInit;
begin
  ProfilerInit;
  InitExportFiles;
  MsgStatInit;
  GrpStatInit;
  ExitSave := ExitProc;
  ExitProc := @ExitUtil;
end;

begin
  PackZeitProMB := GetConfigWord('PackZeitProMB', 30);
  MsgStatTage := GetConfigWord('MsgStatTage', 45);
  TimStatTage := GetConfigWord('TimStatTage', 90);
end.
